#! perl -w
use Tk;
use Tk::Event;
use Tk::DialogBox;
use OLE;
use Win32::Clipboard;
# next - input data from serial port. analyze for probable fixations and read in. every button press would bring up another state - an initial frame for the new state. trial and initial frame information would have to be updated as well.

# function for mesage boxes
use Win32;
use Cwd;

$early_foo = "Wouldn't it be great if I wrote some documentation for this?";
$cwd = cwd();

# display a message box with an exclamation mark and an 'Ok' button
sub MsgBox {
    my ($caption, $message, $icon_buttons) = @_;
    my @return = qw/- Ok Cancel Abort Retry Ignore Yes No/;
    my $result = Win32::MsgBox($message, $icon_buttons, $caption);
    return $result;

#     Icons:
#    0 - no icon
#   16 - Hand
#   32 - Question
#   48 - Exclamation
#   64 - Asterisk
#
# Buttons:
#    0 - Ok
#    1 - Ok, Cancel
#    2 - Abort, Retry, Ignore
#    3 - Yes, No, Cancel
#    4 - Yes, No
#    5 - Retry, Cancel
}

# input the regions file for this program based on command line
use Getopt::Std;

getopt("f");

if ($opt_f ne "") {


  open (REGION, $opt_f . ".rgn");
  while (<REGION>) {
        chomp;
        if (/# region definitions/) {
         $func = "rgns";
         next;
        }
        if (/# variable 1/) {
         $func = "c1";
         next;
        }
        if (/# variable 2/) {
         $func = "c2";
         next;
        }
        if (/# variable 3/) {
         $func = "c3";
         next;
        }
        if (/# graph/) {
         $func = "graph";
         next;
        }
        if (/# end/) {
         $func = "";
         next;
        }
        if ($func eq "rgns") {
         @rgns = split /:/, $_;
         $rgn_label{$rgns[2]} = $rgns[0]; # hash of labels/keys
         $rgn_abbr{$rgns[2]} = $rgns[1]; # hash of abbreviations/keys
         $keys .= $rgns[2];  # list of keys for regex
        }
        if ($func eq "graph") {
          $draw_regions .= $_ . " "; # add to ok regions string
        }
        if ($func eq "c1") {
         @rgns = split /:/, $_;
         $c1_label{++$c1count} = $rgns[0]; # hash of labels/keys
         $c1_abbr{$c1count} = $rgns[1]; # hash of abbreviations/keys
         #$c1_keys .= $c1count;  # list of keys for regex
        }
        if ($func eq "c2") {
         @rgns = split /:/, $_;
         $c2_label{++$c2count} = $rgns[0]; # hash of labels/keys
         $c2_abbr{$c2count} = $rgns[1]; # hash of abbreviations/keys
         #$c2_keys .= $c2count;  # list of keys for regex
        }
        if ($func eq "c3") {
         @rgns = split /:/, $_;
         $c3_label{++$c3count} = $rgns[0]; # hash of labels/keys
         $c3_abbr{$c3count} = $rgns[1]; # hash of abbreviations/keys
         #$c3_keys .= $c3count;  # list of keys for regex
        }
  } # end while region

} else { # else if $opt_f

  $early_foo = "Try loading this program with the arguments '-f regionfile'. See the manual for more information.";

} # end if $opt_f



my $mw=MainWindow->new;
# the program title
$mw->title("SOKATH");
#$mw->setPalette("background" => "white");

# dialog box for delete line entry
$dbox_del = $mw->DialogBox(-title => "Delete Line", -buttons => ["OK", "Cancel"]);
$dbox_del->add(Label, -text => "Enter line number to delete.")->pack(-side => "top");
$dbox_del->add(Entry, -relief => "groove", -borderwidth => 2, -textvariable => \$foo, -takefocus => 1)->pack(-side => "top");

# dialob box for change subject
$dbox_chg = $mw->DialogBox(-title => "Change Subject", -buttons => ["OK", "Cancel"]);
$dbox_chg->add(Label, -text => "Select subject.")->pack(-side => "top");
$listbox = $dbox_chg->add(Scrolled, "Listbox", -relief => "groove", -borderwidth => 2, -selectmode => "single", -scrollbars => "e")->pack(-side => "top");
$dbox_chg->Advertise("listbox" => $listbox);

# dialob box for change trigger
$dbox_trg = $mw->DialogBox(-title => "Change Trigger", -buttons => ["OK", "Cancel"]);
$dbox_trg->add(Label, -text => "Select trigger.")->pack(-side => "top");
$listbox_t = $dbox_trg->add(Scrolled, "Listbox", -relief => "groove", -borderwidth => 2, -selectmode => "single", -scrollbars => "e")->pack(-side => "top");
$dbox_trg->Advertise("listbox_t" => $listbox_t);

#dialog box for amazing ouutput box
$dbox_out = $mw->DialogBox(-title => "Output", -buttons => ["OK"]);
$dbox_out->add(Label, -text => "Right Click to cut and copy.", -width => 150)->pack(-side => "top");
$textbox_t = $dbox_out->add(Scrolled, "Text", -relief => "groove", -borderwidth => 2, -scrollbars => "se")->pack(-fill => "both", -side => "top");
$dbox_out->Advertise("textbox_t" => $textbox_t);

$dbox_out->Subwidget("textbox_t")->insert('end', "Nothing to see here.\n\nAt all.");


# dialog box for new trial
$dbox_tri = $mw->DialogBox(-title => "Change Trial", -buttons => ["OK", "Cancel"]);
$dbox_tri->add(Label, -text => "Block Number.")->pack(-side => "top");
$blk_ent = $dbox_tri->add(Entry, -relief => "groove", -borderwidth => 2, -textvariable => \$blk, -takefocus => 1)->pack(-side => "top");
$dbox_tri->Advertise("blkbox" => $blk_ent);
$dbox_tri->add(Label, -text => "Trial Number.")->pack(-side => "top");
$tri_ent = $dbox_tri->add(Entry, -relief => "groove", -borderwidth => 2, -textvariable => \$tri, -takefocus => 1)->pack(-side => "top");
$dbox_tri->Advertise("tribox" => $tri_ent);
$dbox_tri->add(Label, -text => "Initial Frame Number.")->pack(-side => "top");
$frm_ent = $dbox_tri->add(Entry, -relief => "groove", -borderwidth => 2, -textvariable => \$frm, -takefocus => 1)->pack(-side => "top");
$dbox_tri->Advertise("tribox" => $frm_ent);

# dialog box for change time window
$dbox_tym = $mw->DialogBox(-title => "Change Time Window", -buttons => ["OK", "Cancel"]);
$dbox_tym->add(Label, -text => "Time Window (frames).")->pack(-side => "top");
$tym_ent = $dbox_tym->add(Entry, -relief => "groove", -borderwidth => 2, -textvariable => \$tym, -takefocus => 1)->pack(-side => "top");
$dbox_tym->Advertise("tymbox" => $tym_ent);
$tym = "120";

# dialog box for change time window
$dbox_cnd = $mw->DialogBox(-title => "Condition", -buttons => ["OK", "Cancel"]);

# dialog box for about
$dbox_abo = $mw->DialogBox(-title => "About", -buttons => ["OK"]);
$dbox_abo->add(Label, -text => "SOKATH is a program to aid in the analysis of head mounted eyetracker data. It interacts with Microsoft Excel and saves data in an Excel spreadsheet. Cumulative and momentary probability graphs can be created and viewed online. Strings can be output for further analysis in the companion command line program SSAUL.\n", -justify => "left", -wraplength => 250)->pack(-side => "top", -anchor => "nw");
$dbox_abo->add(Label, -text => "SOKATH was written by Karl Bailey with the help of a gecko, a camel, and a juvenile emu. Report bugs to sokath\@growlers.org.", -justify => "left", -wraplength => 250)->pack(-side => "top", -anchor => "nw");
$dbox_abo->add(Label, -text => "This is version 1.52.\n", -foreground => "blue", -justify => "left", -wraplength => 250)->pack(-side => "top", -anchor => "nw");
$dbox_abo->add(Label, -text => "(c) 2003-2005 Karl Bailey.", -justify => "left", -wraplength => 250)->pack(-side => "top", -anchor => "nw");


# a frame for the menu. Go menu! and one for the message labels. Go labels!
$input2_fr = $mw->Frame(-borderwidth => 0)->pack(-side => "top", -anchor => "nw", -fill => "both", -expand => 1);
$msg_fr = $mw->Frame()->pack(-side => "bottom", -anchor => "sw", -fill => "both", -expand => 1);

# message labels
$msg_fr->Label(-textvariable => \$msg_tri, -font => "Trebuchet 8 bold", -foreground => "blue")->pack(-side => "top", -anchor => "nw");
$msg_tri = "Block: 1  Trial: 1  Init. Frame: 0";
$msg_fr->Label(-textvariable => \$msg_foo, -font => "Trebuchet 8 bold", -foreground => "red")->pack(-side => "top", -anchor => "nw");
$msg_foo = $early_foo;


# and a menu button or two - these are all on the left.

#file menu
$file1_mb = $input2_fr->Menubutton(-text => "File", -tearoff => 0, -underline => 0, -takefocus => 1,
                           -menuitems => [
                                         ["command" => "New Data File", -underline => 0, -accelerator => "Ctrl+N", -command=> sub{\&newxldoc();}],
                                         ["command" => "Open Data File", -underline => 0, -accelerator => "Ctrl+O", -command => sub{\&openxldoc();}],
                                         ["command" => "Save Data File", -underline => 0, -accelerator => "Ctrl+S", -command => sub{\&savexldoc();}],
                                         "-",
                                         ["command" => "Exit", -underline => 1, -command => sub{\&getoutoftown();}]
                                        ])->pack(-side => "left");

$mw->bind("<Control-Key-n>", sub{\&newxldoc();});
$mw->bind("<Control-Key-s>", sub{\&savexldoc();});
$mw->bind("<Control-Key-o>", sub{\&openxldoc();});
# $mw->bind("<Control-Key-x>", sub{\&getoutoftown();});


#data menu
$file2_mb = $input2_fr->Menubutton(-text => "Data", -tearoff => 0, -underline => 0, -takefocus => 1,
                           -menuitems => [
                                         ["command" => "New Sub", -underline => 0, -accelerator => "Ctrl+E", -command => sub{\&newxlsub();}],
                                         ["command" => "Open Sub", -underline => 0, -accelerator => "Ctrl+P", -command => sub{\&chgxlsub();}],
                                         "-",
                                         ["command" => "Delete Last Entry", -underline => 0, -accelerator => "Ctrl+D", -command => sub{\&delxlrow("last");}],
                                         ["command" => "Delete Any Line", -underline => 7, -accelerator => "Ctrl+L", -command => sub{\&delxlany();}],
                                         "-",
                                         ["command" => "New Trial", -underline => 4, -accelerator => "Ctrl+T", -command => sub{\&newxltri();}],
                                        ])->pack(-side => "left");

$mw->bind("<Control-Key-e>", sub{\&newxlsub()});
$mw->bind("<Control-Key-p>", sub{\&chgxlsub()});
$mw->bind("<Control-Key-d>", sub{delxlrow("last")});
$mw->bind("<Control-Key-l>", sub{\&delxlany()});
$mw->bind("<Control-Key-t>", sub{\&newxltri()});
# $mw->bind("<Control-Key-a>", sub{\&sortxlsub()});

# the analysis menu
$file4_mb = $input2_fr->Menubutton(-text => "Analyze", -tearoff => 0, -underline => 0, -takefocus => 1,
                           -menuitems => [
                                         ["command" => "Load Trigger File", -underline => 0, -command => sub{\&loadtrig();}],
                                         ["command" => "Set Trigger", -underline => 4,  -accelerator => "Ctrl-R", -command => sub{\&chgxltrg();}],
                                         ["command" => "Set Time Window", -underline => 9, -command => sub{\&newxltym();}],
                                         ["command" => "Set Condition", -underline => 4, -accelerator => "Ctrl-A", -command => sub{\&newxlcnd();}],
                                         "-",
                                         ["command" => "Momentary (Fix)", -underline => 11, -accelerator => "Ctrl-F", -command => sub{\&graphmeprob();}],
                                         ["command" => "Cumulative (Fix)", -underline => 13, -command => sub{\&graphmecumu();}],
                                         ["command" => "Momentary (Saccade)", -underline => 11, -command => sub{\&graphscprob();}],
                                         ["command" => "Cumulative (Saccade)", -underline => 13, -command => sub{\&graphsccumu();}],
                                         ["command" => "Make Window Strings", -underline => 2, -command => sub{\&makestrings();}],
                                         ["command" => "Make Region Strings", -underline => 5, -command => sub{\&graphmealt();}],
                                         ["command" => "Output Strings to Disk", -accelerator => "Ctrl-M", -command => sub{\&alltrgout();}],
                                         "-",
                                         ["command" => "Output", -underline => 0, -command => sub{\&outinfo();}],
                                         ["command" => "Toggle Updating", -accelerator => "Ctrl-G", -underline => 2, -command => sub{\&toggleup();}],
                                        ])->pack(-side => "left");


# the help menu goes on the right. Years from now, people will wonder why, and I'll tell them it's because something wouldn't work awhile ago.
$file3_mb = $input2_fr->Menubutton(-text => "Help", -tearoff => 0, -underline => 0, -takefocus => 1,
                           -menuitems => [
                                         ["command" => "About", -underline => 0, -command => sub{\&showabout();}],
                                        ])->pack(-side => "right");

$mw->bind("<Control-Key-h>", sub{$msg_foo = "Wouldn't it be great if I wrote some documentation for this?"});
$mw->bind("<Control-Key-k>", sub{\&showabout();});
$mw->bind("<Control-Key-g>", sub{\&toggleup();});
$mw->bind("<Control-Key-q>", sub{\&cliptoggle();});
$mw->bind("<Control-Key-a>", sub{\&newxlcnd();});
$mw->bind("<Control-Key-f>", sub{\&graphmeprob();});
$mw->bind("<Control-Key-r>", sub{\&chgxltrg();});
$mw->bind("<Control-Key-m>", sub{\&alltrgout();});


# the main frames layout!
$input1_fr = $mw->Frame(-borderwidth => 0, -relief => "groove")->pack(-side => "bottom");
$left_fr = $input1_fr->Frame(-borderwidth => 0, -relief => "groove")->pack(-side => "left", -anchor => "n");
$right_fr = $input1_fr->Frame(-borderwidth => 2, -relief => "groove")->pack(-side => "right", -anchor => "n");

# content for the left frame! zow!
$lfr1 = $left_fr->Frame(-borderwidth => 2, -relief => "groove")->pack(-side => "top", -anchor => "nw", -expand => 1, -fill => "both", -padx => 5);
$lfr1->Label(-text => "Regions.")->pack(-side => "top", -anchor => "nw");

# radio buttons with input abilities
@colors = qw(#e31a1c #377db8 #4daf4a #984ea3 #ff7f00 #ffff33 #a65628 #f781bf #999999 #000000);
$c = 0;
foreach (sort keys %rgn_label) {
$lfr1->Radiobutton(
                      -text => $rgn_label{$_} . " [$_]",
                      -value => $_,
                      -variable => \$rb_value,
                      -command => \&inputline,
                      -foreground => $colors[$c],
                      -font => "System 7 bold",
                      -activeforeground => $colors[$c],
                      -activebackground => "#eeeeee",
                      -selectcolor => "white",
                      )->pack(-side => "top", -anchor => "nw");

$colors{$rgn_abbr{$_}} = $colors[$c];
$c += 1;
if ($c == 10) {
 $c = 9;
}
# map single keys onto buttons

$mw->bind("<Key-$_>", \&inputkey);

}

# radio  buttons for condition 1
$lfr2 = $left_fr->Frame(-borderwidth => 2, -relief => "groove")->pack(-side => "top", -anchor => "nw", -expand => 1, -fill => "both", -padx => 5, -pady => 2);
$lfr2->Label(-text => "Variable 1")->pack(-side => "top", -anchor => "nw");
$dbox_cnd->add(Label, -text => "Variable 1")->pack(-side => "top");

foreach (sort keys %c1_label) {
$lfr2->Radiobutton(
                      -text => $c1_label{$_} . " [CTRL-$_]",
                      -value => $_,
                      -variable => \$rb_c1,
                      -command => \&inputline,
                      -activebackground => "#eeeeee",
                      -selectcolor => "white",
                      )->pack(-side => "top", -anchor => "nw");

$rb_dc1 = $dbox_cnd->add(Radiobutton,
                      -text => $c1_label{$_},
                      -value => $_,
                      -variable => \$this_c1,
                      -activebackground => "#eeeeee",
                      -selectcolor => "white",
                      )->pack(-side => "top", -anchor => "nw");

$dbox_cnd->Advertise("c1box" => $rb_dc1);


# map single keys onto buttons

$mw->bind("<Control-Key-$_>", [sub{$rb_c1 = $_[1];}, $_]);

}
$rb_c1 = 1;
$this_c1 = 1;

# radio  buttons for condition 2
$lfr3 = $left_fr->Frame(-borderwidth => 2, -relief => "groove")->pack(-side => "top", -anchor => "nw", -expand => 1, -fill => "both", -padx => 5, -pady => 2);
$lfr3->Label(-text => "Variable 2")->pack(-side => "top", -anchor => "nw");
$dbox_cnd->add(Label, -text => "Variable 2")->pack(-side => "top");

foreach (sort keys %c2_label) {
$lfr3->Radiobutton(
                      -text => $c2_label{$_} . " [CTRL-F$_]",
                      -value => $_,
                      -variable => \$rb_c2,
                      -command => \&inputline,
                      -activebackground => "#eeeeee",
                      -selectcolor => "white",
                      )->pack(-side => "top", -anchor => "nw");

$rb_dc2 = $dbox_cnd->add(Radiobutton,
                      -text => $c2_label{$_},
                      -value => $_,
                      -variable => \$this_c2,
                      -activebackground => "#eeeeee",
                      -selectcolor => "white",
                      )->pack(-side => "top", -anchor => "nw");

$dbox_cnd->Advertise("c2box" => $rb_dc2);

# map single keys onto buttons

$mw->bind("<Control-F$_>", [sub{$rb_c2 = $_[1];}, $_]);

}
$rb_c2 = 1;
$this_c2 = 1;

# radio  buttons for condition 3
$lfr4 = $left_fr->Frame(-borderwidth => 2, -relief => "groove")->pack(-side => "top", -anchor => "nw", -expand => 1, -fill => "both", -padx => 5, -pady => 2);
$lfr4->Label(-text => "Variable 3")->pack(-side => "top", -anchor => "nw");
$dbox_cnd->add(Label, -text => "Variable 3")->pack(-side => "top");

foreach (sort keys %c3_label) {
$lfr4->Radiobutton(
                      -text => $c3_label{$_} . " [F$_]",
                      -value => $_,
                      -variable => \$rb_c3,
                      -command => \&inputline,
                      -activebackground => "#eeeeee",
                      -selectcolor => "white",
                      )->pack(-side => "top", -anchor => "nw");

$rb_dc3 = $dbox_cnd->add(Radiobutton,
                      -text => $c3_label{$_},
                      -value => $_,
                      -variable => \$this_c3,
                      -activebackground => "#eeeeee",
                      -selectcolor => "white",
                      )->pack(-side => "top", -anchor => "nw");

$dbox_cnd->Advertise("c3box" => $rb_dc3);

# map single keys onto buttons

$mw->bind("<F$_>", [sub{$rb_c3 = $_[1];}, "$_"]);

}
$rb_c3 = 1;
$this_c3 = 1;

# content for the right frame!
$right_fr->Label(-text => "Input frame number below and select a region.")->pack(-side => "top", -anchor => "nw");
$text_ent = $right_fr->Entry(-textvariable => \$frame_num, -relief => "solid", -border => 1)->pack(-side => "top", -anchor => "nw", -padx => 2);
$canvas = $right_fr->Scrolled("Canvas", -background => "white", -width => 430, -height => 200, -scrollbars => "e", -scrollregion => [0,0,400,200], -borderwidth => 1, -relief => "solid")->pack(-side => "top");
$canvas -> Subwidget("yscrollbar") -> configure(-relief => "solid", -troughcolor => "white", -background => "white");
$graph = $right_fr->Canvas(-background => "white", -width => 448, -height => 118, -borderwidth => 1, -relief => "solid")->pack(-side => "top");
$canvas->createText(5,5, -text => "Data for current subject.\nline\tSub\tBlk\tTrl\tFrm\tRgn\tC1\tC2\tC3\t\n", -anchor => "nw", -tags => "intext", -font => "Trebuchet 8 normal");

# lines for the graph region
$mgn = 24;
$bdr = 9;
$graph->createLine($mgn, 100 + $bdr, $mgn, $bdr, -arrow => "last", -tags => "yaxis");
$graph->createLine($mgn, 100 + $bdr, 400 + $mgn, 100 + $bdr, - arrow => "last", -tags => "xaxis");
$graph->createText(12,59, -text => "f\ni\nx\n \np\nr\no\nb", -anchor => "center", -tags => "xtext", -font => "Trebuchet 8 normal");
$graph->createText(224,115, -text => "Time (ms)", -anchor => "center", -tags => "ytext", -font => "Trebuchet 8 normal");
$right_fr->Label(-textvariable => \$graph_foo, -font => "Trebuchet 8 bold", -foreground => "black")->pack(-side => "top", -anchor => "nw");
$go_time = "120";
$go_cond = $c1_abbr{$this_c1} . " :: " . $c2_abbr{$this_c2} . " :: " . $c3_abbr{$this_c3};  # fix this initially, hmm
$go_trig = "none";
$graph_foo = "Time Window: $go_time  Condition: $go_cond  Trigger: $go_trig";

# map alt keys to menu

$mw->bind("<Alt_L>", sub{$file1_mb->focus; $inhibit = 1;});
$mw->bind("<Escape>", sub{if ($inhibit == 1) {$file1_mb->eventGenerate('<Enter>'); $file1_mb->eventGenerate('<ButtonRelease-1>'); $inhibit = 0; $text_ent->focus()}});
$mw->bind("<Alt-F4>", sub{getoutoftown();});


# print key or button to command line window.
#$mw->bind("<Key>", [sub {print "ARGS: @_\n"; }, Ev('k'), Ev('K') ]);
#$mw->bind("<Button>", [sub {print "ARGS: @_\n"; }, Ev('b')]);

# function for keypress radio button emulation

sub inputkey {
if ($inhibit != 1) {
# match key and set radio button to key
$frame_num =~ /([$keys])/;
$rb_value = $1;

#remove keypress from the text entry string
chop($frame_num);

# run the inputline function
&inputline;
}
}

#input line function for radiobuttons

sub inputline {
if ($xldocexists == 1) {
 if ($frame_num eq "") { # if there is nothing the text entry box
     $whatyousay = MsgBox("Look out, genius!", "You forgot a frame value.\nAre you mad?", 36);
     $msg_foo = "Could not add new row.";
     #print "$whatyousay\n";
     $text_ent->focus();
 } elsif ($frame_num =~ /^[0-9]+$/) { #if there is numerical data in the text entry box
     $subframe = $frame_num - $go_frame;
     if ($subframe >= 0) {
     my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;
     if ($rowcount <= 10) {
      $scrollyeah = 0;
     } else {
      $scrollyeah = 1;
     }
     @datas = ($worksheet->{Index}, $go_block, $go_trial, $subframe, $rgn_abbr{$rb_value}, $c1_abbr{$rb_c1}, $c2_abbr{$rb_c2}, $c3_abbr{$rb_c3});
     newxlrow(@datas);
     ++$rowcount;
     unshift(@datas, "$rowcount:");
     unshift(@datas, $scrollyeah);
     uptext(@datas);
     $frame_num = "";
     $needsort[$worksheet->{Index}] = 1;
     $msg_foo = "New row added ($rowcount)";
     } else {
     $whatyousay = MsgBox("Look out, genius!", "Frame must be after initial frame!", 16);
     $msg_foo = "Could not add new row.";
     }
     $text_ent->focus();
 } else {  # if there is non numerical data in the text entry box
     $whatyousay = MsgBox("Look out, genius!", "That needs to be a number.", 16);
     $msg_foo = "Could not add new row.";
     #print "$whatyousay\n";
     $frame_num = "";
     $text_ent->focus();
 }
} else {
$msg_foo = "There is no data file currently open.";
}
}

# update text in canvas. now with scrolling!
sub uptext {
   my $info = "";
   undef $upc;
   foreach (@_) {
     $upc ++;
     if ($upc > 1) {
     $info .= $_ . "\t";
     }
   }
if ($updatego == 1) {
   $canvas->insert("intext", "end", "$info\n");

   #my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;
   if ($_[0] > 0) {
   my @canvas_h = $canvas->cget(-scrollregion);
#   print $canvas_h[3] . "\n";
   $canvas_h[3] += 14;
   $canvas->configure(-scrollregion => [@canvas_h]);
   $canvas->yviewMoveto(1);
   #$canvas->Subwidget("yscrollbar")->set(0.5, 0.6);
   #($sc_first, $sc_last) =
   #print "$sc_first => $sc_last\n";

   }
  }
}

# start with the cursor in the text entry box.
$text_ent->focus();
# open a new excel document

# set up inhibit val and xl doc exists val
$inhibit = 0;
$xldocexists = 0;
$xlappexists = 0;
$go_trial = 1;
$tri = 1;
$go_block = 1;
$blk = 1;
$go_frame = 0;
$frm = 0;
$trigger_exists = 0;
$updatego = 1;
$intext_msg = "Data for current subject.";
$cliptoggle = 0;
$clip = Win32::Clipboard();

$mw->resizable(0,0);

# the program icon
my $image=$mw->Photo(-file=>"sokath.bmp");
$mw->Icon(-image => $image);


# apparently, this needs to be after any other thing involving the main window.
# my $mask=$mw->Photo(-file=>"mask.bmp");
# print $mask->data();
# my $mask=$mw->Photo(-file=>"mask.bmp");
# my $bitmask = $mw->Bitmap(-data => "
#                                    {#000000 #000000 #000000 #000000 #000000 #000000}
#                                    {#000000 #000000 #000000 #000000 #000000 #000000}
#                                    {#000000 #000000 #000000 #000000 #000000 #000000}
#                                    ");
#$mw->iconmask($bitmask);

MainLoop;
getoutoftown();

# ---------------------
# excel spreadsheet functions

# invent a new excel document
sub newxldoc {
   if ($xlappexists == 0) {
   $xl_app = CreateObject OLE 'Excel.Application' || die $!;

   $xl_app->{'Visible'} = 0;
   $xl_app->{'DisplayAlerts'} = 0;
   $xl_app->{'SheetsInNewWorkbook'} = 3;
   $workbook = $xl_app->Workbooks->Add();
   $worksheet = $workbook->Worksheets('Sheet1');
   $worksheet->{Name} = "subject 1";
   if ($workbook->Worksheets->Count == 3) {
   $workbook->Worksheets('Sheet2')->Delete();
   $workbook->Worksheets('Sheet3')->Delete();
   }
   $worksheet->Range("A1:H1")->{'Value'} = [qw(Sub Blk Trl Frm Rgn C1 C2 C3)];
   $xldocexists = 1;
   $xlappexists = 1;
   #$file1_mb->entryconfigure(0, -state => "disabled");
   $file1_mb->eventGenerate('<Escape>');
   $msg_foo = "New data file created.";
   } else {
    my $okgo = MsgBox("Start New Project", "Any unsaved data will be permanently deleted!", 17);
    if ($okgo == 1) {
    $xl_app->ActiveWorkbook->Close(0);
    $workbook = $xl_app->Workbooks->Add();
    $worksheet = $workbook->Worksheets(1);
    $worksheet->{Name} = "subject 1";
    $workbook->Worksheets('Sheet2')->Delete();
    $workbook->Worksheets('Sheet3')->Delete();
    $worksheet->Range("A1:H1")->{'Value'} = [qw(Sub Blk Trl Frm Rgn C1 C2 C3)];
    $xldocexists = 1;
    $msg_foo = "New data file created.";
    outxlpage();
    }
   }
}

#open new excel workbook
sub openxldoc {
    my $okgo = MsgBox("Open New Project", "Any unsaved data will be permanently deleted!", 17);
  if ($okgo == 1) {
   $types = [['sokath data files', '*.skh']];
#    my $getdoc = $mw->getOpenFile(-filetypes=>$types, -initialdir => $cwd);
   my $getdoc = $mw->getOpenFile(-initialdir => $cwd);
   while ($getdoc) {
   # regular expression to flip slashes!
   #print "$getdoc\n";
   $getdoc = fixslash($getdoc);
   #print "$getdoc\n";
   if ($xldocexists == 1) {
    $xl_app->ActiveWorkbook->Close(0);
   } elsif ($xlappexists == 0) {
   $xl_app = CreateObject OLE 'Excel.Application' || die $!;

   $xl_app->{'Visible'} = 0;
   $xl_app->{'DisplayAlerts'} = 0;
   }
   if ($workbook = $xl_app->Workbooks->Open($getdoc)) {
    $worksheet = $workbook->Worksheets('subject 1');
    $msg_foo = "Opened $getdoc.";
    $currentfile = $getdoc;
    outxlpage();
    $xldocexists = 1;
    $xlappexists = 1;
    my $sheetcount = $workbook->Worksheets->Count;
    for ($i = 1; $i <= $sheetcount+1; $i++) {
     $needsort[$i] = 1;
    }
   } else {
    $oops = OLE->LastError();
    print $oops;
    $msg_foo = "Could not open $getdoc.";
   }
   undef $getdoc;
   }
   $file2_mb->eventGenerate('<Escape>');
 }
}

# insert a new worksheet for a happy happy subject
sub newxlsub {
if ($xldocexists == 1) {
my $sheetcount = $workbook->Worksheets->Count;
$workbook->Worksheets->Add({
                           After => $workbook->Worksheets($sheetcount),
                          });
$worksheet = $xl_app->ActiveSheet;
$worksheet->{Name} = "subject " . ($sheetcount+1); # I'm here!
$worksheet->Range("A1:H1")->{'Value'} = [qw(Sub Blk Trl Frm Rgn C1 C2 C3)];
$msg_foo = "Added subject " . ($sheetcount+1);
outxlpage();
$file2_mb->eventGenerate('<Escape>');
} else {
$msg_foo = "How can I add a subject to a nonexistant data file?"
}
}

# insert a new excel row at the end of the sheet.
sub newxlrow {
   my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count + 1;
   $worksheet->Range("A$rowcount:H$rowcount")->{'Value'} = [@_];
}

# delete last row
sub delxlrow {
if ($xldocexists == 1) {

   my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;
   if ($rowcount > 1) {
   if (!$_[0]) {
      # need an argument, fool!
      print "foo! somehow there was no argument passed.";
   } elsif ($_[0] eq "last") {
      $worksheet->Rows("$rowcount:$rowcount")->Select();
      $xl_app->Selection->Delete()->{'Shift'} = "x1Up";
      $msg_foo = "Last row deleted.";
      outxlpage();
         } else {
      $worksheet->Rows("$_[0]:$_[0]")->Select();
      $xl_app->Selection->Delete()->{'Shift'} = "x1Up";
   }}
   $file2_mb->eventGenerate('<Escape>');
} else {
$msg_foo = "You cannot delete nothing."
}

}

sub delxlany {
    if ($xldocexists == 1) {
    $foo = "";
    my $button = $dbox_del->Show;
    if ($button eq "OK" and $foo =~ /[0-9]+/ and $foo > 1) {
    $worksheet->Rows("$foo:$foo")->Select();
    $xl_app->Selection->Delete()->{'Shift'} = "x1Up";
    $msg_foo = "Row $foo deleted.";
    outxlpage();
    }
    } else {
    $msg_foo = "You cannot delete nothing."
    }
}

# read out every row except the first header row
sub outxlrow {
   my @canvas_h = $canvas->cget(-scrollregion);
   $canvas_h[3] = 200;
   $canvas->configure(-scrollregion => [@canvas_h]);

#         print "outxl count " . $worksheet->Cells(1,1)->CurrentRegion->Rows->Count . "\n";
#         print "outxl current " . $worksheet->{'Index'} . "\n";
   my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;
   # print $rowcount . "\n";
   $canvas->dchars("intext", 0, "end");
   $canvas->insert("intext", "end", "$intext_msg\n");
   for ($i=1; $i <= $rowcount; $i++) {
        # print $i . "=>" . $worksheet->Cells($i,1)->Value . "\n";
        my $array = $worksheet->Range("A$i:H$i")->{'Value'};        # get the contents
        foreach my $ref_array (@$array) {                     # loop through the array
                                                              # referenced by $array
           undef @cat;
             if ($i <= 11) {
             push(@cat, "0");
#             print $cat[0];
             } else {
             push(@cat, "1");
             }
             if ($i == 1) {
             push(@cat, "line");
             } else {
             push(@cat, "$i:");
             }
           foreach my $scalar (@$ref_array) {
             push(@cat, $scalar);
           }
           uptext(@cat);

}

}
}

sub outxlpage {
   my @canvas_h = $canvas->cget(-scrollregion);
   $canvas_h[3] = 200;
   $canvas->configure(-scrollregion => [@canvas_h]);

#         print "outxl count " . $worksheet->Cells(1,1)->CurrentRegion->Rows->Count . "\n";
#         print "outxl current " . $worksheet->{'Index'} . "\n";
   my $grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
   my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;
   my $n = 0;
   # print $rowcount . "\n";
   $canvas->dchars("intext", 0, "end");
   $canvas->insert("intext", "end", "$intext_msg\n");
for $m (0 .. $rowcount - 1) {

# get data out of array

        # print $i . "=>" . $worksheet->Cells($i,1)->Value . "\n";
        foreach my $ref_array (@$grapharray[$m]) {                     # loop through the array
                                                              # referenced by $array
           undef @cat;
             if ($m <= 11) {
             push(@cat, "0");
#             print $cat[0];
             } else {
             push(@cat, "1");
             }
             if ($m == 0) {
             push(@cat, "line");
             } else {
             $n = $m + 1;
             push(@cat, "$n:");
             }
           foreach my $scalar (@$ref_array) {
             push(@cat, $scalar);
           }
           uptext(@cat);

}

}
}


sub sortxlsub {
if ($xldocexists == 1 and $needsort[$worksheet->{Index}] == 1) {
# get current spreadsheet
        my $sortarray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
#         print "sort sheet " . $worksheet->{'Index'} . "\n";
# delete the spreadsheet. yikes!
$worksheet->Cells->Select();
$xl_app->Selection->Delete();

#         print "sort count " . $worksheet->Cells(1,1)->CurrentRegion->Rows->Count . "\n";
#         sleep 10;
# write the spreadsheet into an array, and make some hashes.
# ignore the first row when writing hashes
        my $srow = 1;
        my $scol = 1;
        undef @gotarray;
        undef %blk_sort;
        undef @trl_sort;
        undef @frm_sort;
        undef %all_sort;
        for (@$sortarray) {
            for (@$_) {
                $gotarray[$srow][$scol] = $_;
                if ($srow != 1) {
#                 print $scol;
                if ($scol == 2) {
                $blk_sort{$_} = $srow;
#                 print "$blk_sort{$_}";
                $this_blk = $_;
                }
                if ($scol == 3) {
                $trl_sort[$this_blk]{$_} = $srow;
#                 print "$trl_sort[$this_blk]{$_}";
                $this_trl = $_;
                }
                if ($scol == 4) {
                $frm_sort[$this_blk][$this_trl]{$_} = $srow;
#                 print "$frm_sort[$this_blk][$this_trl]{$_}";
                $this_str = "b" . $this_blk . "t" . $this_trl . "f" . $_;
                $all_sort{$this_str} = $srow;
                }
                }
                $scol += 1;
            }
            $scol = 1;
            if ($srow != 1) {
#             print "\n";
            }
            $srow += 1;

        }

@datas = ($gotarray[1][1], $gotarray[1][2], $gotarray[1][3], $gotarray[1][4], $gotarray[1][5], $gotarray[1][6], $gotarray[1][7], $gotarray[1][8]);
$worksheet->Range("A1:H1")->{'Value'} = [@datas];

foreach (sort { $a <=> $b } keys %blk_sort) {
# print "$_: ";
$this_blk = $_;
foreach (sort { $a <=> $b } keys %{$trl_sort[$this_blk]}) {
# print "($_)";
$this_trl = $_;
foreach (sort { $a <=> $b } keys %{$frm_sort[$this_blk][$this_trl]}) {
# print "$_ ";
$this_str = "b" . $this_blk . "t" . $this_trl . "f" . $_;
# print "$this_str ($all_sort{$this_str})";
my $e = $all_sort{$this_str};
@datas = ($gotarray[$e][1], $gotarray[$e][2], $gotarray[$e][3], $gotarray[$e][4], $gotarray[$e][5], $gotarray[$e][6], $gotarray[$e][7], $gotarray[$e][8]);
newxlrow(@datas);
}
}
# print "\n";
}
#         print $worksheet->Cells(1,1)->CurrentRegion->Rows->Count . "\n";

outxlpage();
#         print $worksheet->Cells(1,1)->CurrentRegion->Rows->Count . "\n";

$needsort[$worksheet->{Index}] = 0;
$msg_foo = "Trials for this subject sorted.";
} else {
$msg_foo = "You can't sort what doesn't need to be sorted.";
}
}

# save the document
sub savexldoc {
  if ($xldocexists == 1) {
   $types = [['sokath data files', '*.skh']];
#    my $savedoc = $mw->getSaveFile(-filetypes => $types, -defaultextension => ".skh", -initialfile => $currentfile);
   my $savedoc = $mw->getSaveFile(-defaultextension => ".skh", -initialfile => $currentfile);
   while ($savedoc) {
   $savedoc = fixslash($savedoc);
   my $filename = $savedoc;
   # unlink $filename if -f $filename;
   if ($workbook->SaveAs($filename)) {
   $msg_foo = "Saved to " . $workbook->{'Path'} . "\\" . $workbook->{'Name'};
   $savedoc = "";
   } else {
   $msg_foo = "Could not save $savedoc.";
   }
   }
   $file1_mb->eventGenerate('<Escape>');
  } else {
    $msg_foo = "There's nothing to save. Not even crumbs!";
  }
}

# change the current subject
sub chgxlsub {
if ($xldocexists == 1) {
  my $sheetcount = $workbook->Worksheets->Count;
  undef @subjects;
  for ($i = 1; $i <= $sheetcount; $i++) {
     #print my $thisname = $workbook->Worksheets($i)->{'Name'} . "\n";
     push(@subjects, $workbook->Worksheets($i)->{'Name'});
  }
  $dbox_chg->Subwidget("listbox")->insert('end', @subjects);
  $dbox_chg->Subwidget("listbox")->selectionSet(0);
  my $button = $dbox_chg->Show;
  #print "@subjects\n";
  if ($button eq "OK") {
  my $selsub = $dbox_chg->Subwidget("listbox")->curselection();
  my $selsheet = $dbox_chg->Subwidget("listbox")->get($selsub);
  $worksheet = $workbook->Worksheets($selsheet);
  $msg_foo = "Subject is now $selsheet.";
  outxlpage();
  }
  $dbox_chg->Subwidget("listbox")->delete(0, 'end');
} else {
$msg_foo = "You want me to change from one subject that doesn't exist to another that also doesn't exist. Ha!";
}
}

sub newxltri {
my $button = $dbox_tri->Show;
if ($button eq "OK" and $tri =~ /[0-9]+/ and $blk =~ /[0-9]+/) {
    $go_trial = $tri;
    $go_block = $blk;
    $go_frame = $frm;
    $msg_tri = "Block: $go_block  Trial: $go_trial  Init. Frame: $go_frame";
    $msg_foo = "Block/Trial definition changed."
    }
}

sub newxltym {
my $button = $dbox_tym->Show;
if ($button eq "OK" and $tym =~ /[0-9]+/) {
    $go_time = $tym;
    $graph_foo = "Time Window: $go_time  Condition: $go_cond  Trigger: $go_trig";
    $msg_foo = "Time Window changed."
    }
}

sub newxlcnd {
my $button = $dbox_cnd->Show;
$go_cond = $c1_abbr{$this_c1} . " :: " . $c2_abbr{$this_c2} . " :: " . $c3_abbr{$this_c3};
$graph_foo = "Time Window: $go_time  Condition: $go_cond  Trigger: $go_trig";
}

sub graphmeprob {
$dots_foo = "";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();


#clear lines
foreach (sort values %rgn_abbr) {
$graph->delete("fooline");
}

# initialize array for time window to prevent irriating errors in -w mode
undef $graphme;
undef %coordlist;

my $trigger = 0;
my $lastblock = -1;
my $lasttrial = -1;

# get all lines
my $grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


$currentsheet = $worksheet->{'Index'};
for ($h = 0; $h <= $go_time; $h++) {
foreach (sort values %rgn_abbr) {
$graphme[$h]{$_} = 0;
}
}

for $p (1 .. $workbook->Worksheets->Count) {
$worksheet = $workbook->Worksheets($p);
$workbook->Worksheets($p)->Activate();

sortxlsub();
$dots_foo .= "S$p ... ";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();


$lastblock = -1;
$lasttrial = -1;

# get all lines
undef $grapharray;
$grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
$rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


# initialize last frame as 0 or trigger

# loop through all lines
for $m (2 .. $rowcount) {

# get data out of array
$mrow = $m - 1;
$thisblock = $$grapharray[$mrow][1];
$thistrial = $$grapharray[$mrow][2];
$thisframe = $$grapharray[$mrow][3];
$thisregion = $$grapharray[$mrow][4];
$thiscnd1 = $$grapharray[$mrow][5];
$thiscnd2 = $$grapharray[$mrow][6];
$thiscnd3 = $$grapharray[$mrow][7];



# get trigger for this trial
# in future version

# initialize new block/trial loop
if ($lastblock != $thisblock || $lasttrial != $thistrial) {

# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region
$lastregion = $thisregion;

# reset toohigh
$toohigh = 0;

if ($trigger_exists == 1) {
$trigger = $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set];
# print $thistrial . " - " . $this_c1 . " - " . $this_c2 . " - " . $this_c3 . " - " . $trigger_set . " - " . $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set] . "\n";
# $trigger = 0;
} else {
$trigger = 0;
}


} else {
# for each frame, if the conditions match,
# and it's post trigger
if ($thiscnd1 eq $c1_abbr{$this_c1} && $thiscnd2 eq $c2_abbr{$this_c2} && $thiscnd3 eq $c3_abbr{$this_c3} && $thisframe >= $trigger && $toohigh == 0) {
# print "$m\n";
# from the last frame number to this one -1,
for $n ($lastframe .. $thisframe-1) {
# add one to each frame for the last region
if ($n > ($trigger + $go_time)) {
next;
}
# print "($thistrial) $lastframe:$thisframe\t$n - $trigger\n";
if ($n >= $trigger) {
$graphme[$n - $trigger]{$lastregion} += 1;
}
}
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
$lastregion = $thisregion;
if ($thisframe >= ($trigger + $go_time)) {
$toohigh = 1;
}
} else { # end if
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
$lastregion = $thisregion;

}
} # end else

# record this trial and block number
$lasttrial = $thistrial;
$lastblock = $thisblock;

}
}

  $dbox_out->Subwidget("textbox_t")->delete("1.0", 'end');
  if ($cliptoggle == 1) {
   $clip->Empty();
  }
for $divreg (keys %{$graphme[0]}) {
 $dbox_out->Subwidget("textbox_t")->insert('end', $divreg . "\t");
  if ($cliptoggle == 1) {
    $currentclip = $clip->Get();
    $clip->Set($currentclip . $divreg . "\t");
  }
}

$dbox_out->Subwidget("textbox_t")->insert('end', "iter\t\n");
  if ($cliptoggle == 1) {
    $currentclip = $clip->Get();
    $clip->Set($currentclip . "iter\t\n");
  }



# for each frame
for $o (0 .. $go_time) {

# add up all of the regions
$regtot = 0;
for $addreg (keys %{$graphme[$o]}) {
$regtot += $graphme[$o]{$addreg};
}

# for each region
for $divreg (keys %{$graphme[$o]}) {
if ($regtot != 0) {
# divide by the number of fixations
$thisprob = $graphme[$o]{$divreg} / $regtot;
} else {
$thisprob = 0;
}
$xcoord = ((400 / $go_time) * $o) + $mgn;
$ycoord = $bdr + (100 * (1-$thisprob));
# add coordinates to list
push @{ $coordlist{$divreg} }, $xcoord, $ycoord;
$thisprob_dec = sprintf("%.3f", $thisprob);
$dbox_out->Subwidget("textbox_t")->insert('end', $thisprob_dec . "\t");
  if ($cliptoggle == 1) {
    $currentclip = $clip->Get();
    $clip->Set($currentclip . $thisprob_dec . "\t");
  }

}
$dbox_out->Subwidget("textbox_t")->insert('end', "$o\t\n");
  if ($cliptoggle == 1) {
    $currentclip = $clip->Get();
    $clip->Set($currentclip . "$o\t\n");
  }

}

# thisprob needs to be printed out somewhere for each thing. tab after each, and newline at the end. write out to a box of some sort?

# $coordlist{"BM"} = [$mgn, $bdr + 10, $mgn + 400, $bdr + 10];
# $coordlist{"TP"} = [$mgn, $bdr + 20, $mgn + 400, $bdr + 20];
# $coordlist{"RT"} = [$mgn, $bdr + 30, $mgn + 400, $bdr + 30];
# $coordlist{"LT"} = [$mgn, $bdr + 40, $mgn + 400, $bdr + 40];
# $coordlist{"XX"} = [$mgn, $bdr + 50, $mgn + 400, $bdr + 50];

#output coordinates for each region
$c = 0;
for $drawregs (sort keys %{$graphme[0]}) {
if ($draw_regions =~ /$drawregs/) {
$graph->createLine(@{$coordlist{$drawregs}}, -fill => $colors{$drawregs}, -tags => "fooline", -joinstyle => "round", -width => 2);
# print $drawregs . "\n";
}
$c += 1;
}

# print array for test purposes
# print "{ ";
# for $nameregs (keys %{$graphme[0]}) {
#  print "$nameregs ";
# }
# print "}\n";

# print data to stdout
# for $k (0 .. $#graphme) {
#    print "{ ";
#    for $regs (keys %{$graphme[$k]}) {
#        print "$graphme[$k]{$regs}  ";
#    }
#    print "}\n";
# }
$worksheet = $workbook->Worksheets($currentsheet);
$workbook->Worksheets($currentsheet)->Activate();

# print $worksheet->{'Name'} . "\n";
$msg_foo = "Momentary probability graph created for selected condition.";
$file4_mb->eventGenerate('<Escape>');


}

sub graphmecumu {
$dots_foo = "";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();

#clear lines
foreach (sort values %rgn_abbr) {
$graph->delete("fooline");
}

# initialize array for time window to prevent irriating errors in -w mode
undef $graphme;
undef %coordlist;

my $trigger = 0;
my $lastblock = -1;
my $lasttrial = -1;
my $alltrials = 0;

# get all lines
my $grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


$currentsheet = $worksheet->{'Index'};
for ($h = 0; $h <= $go_time; $h++) {
foreach (sort values %rgn_abbr) {
$graphme[$h]{$_} = 0;
}
}

for $p (1 .. $workbook->Worksheets->Count) {
$worksheet = $workbook->Worksheets($p);
$workbook->Worksheets($p)->Activate();

sortxlsub();
$dots_foo .= "S$p ... ";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();

$lastblock = -1;
$lasttrial = -1;

# get all lines
undef $grapharray;
$grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
$rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


# initialize last frame as 0 or trigger

# loop through all lines
for $m (2 .. $rowcount) {

# get data out of array
$mrow = $m - 1;
$thisblock = $$grapharray[$mrow][1];
$thistrial = $$grapharray[$mrow][2];
$thisframe = $$grapharray[$mrow][3];
$thisregion = $$grapharray[$mrow][4];
$thiscnd1 = $$grapharray[$mrow][5];
$thiscnd2 = $$grapharray[$mrow][6];
$thiscnd3 = $$grapharray[$mrow][7];



# get trigger for this trial
# in future version

# initialize new block/trial loop
if ($lastblock != $thisblock || $lasttrial != $thistrial) {

# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region
$lastregion = $thisregion;

if ($trigger_exists == 1) {
$trigger = $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set];
#  print $thistrial . " - " . $this_c1 . " - " . $this_c2 . " - " . $this_c3 . " - " . $trigger_set . " - " . $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set] . "\n";
} else {
$trigger = 0;
}


# reset toohigh
$toohigh = 0;
foreach (sort values %rgn_abbr) {
$stopcumu{$_} = 0;
}
if ($thiscnd1 eq $c1_abbr{$this_c1} && $thiscnd2 eq $c2_abbr{$this_c2} && $thiscnd3 eq $c3_abbr{$this_c3}) {
$alltrials += 1;
}

} else {
# for each frame, if the conditions match,
# and it's post trigger
if ($thiscnd1 eq $c1_abbr{$this_c1} && $thiscnd2 eq $c2_abbr{$this_c2} && $thiscnd3 eq $c3_abbr{$this_c3} && $thisframe >= $trigger && $toohigh == 0 && $stopcumu{$lastregion} == 0) {
$stopcumu{$lastregion} = 1;
# print "$m\n";
# from the last frame number to this one -1,
for $n ($lastframe .. $trigger + $go_time) {
# add one to each frame for the last region
if ($n > $trigger + $go_time) {
next;
}
# don't let negative numbers get you down.
if ($n - $trigger < 0) {
next;
}
$graphme[$n - $trigger]{$lastregion} += 1;
# $zoog = $n-$trigger;
# print $zoog . " ";
# print $n . " - " . $trigger . " = " . $zoog . " : " . $lastregion . "\n";
}
# if ($lastregion eq "TL") {
# print "\n(" . $p . ")" . $thistrial . ": " . $lastregion . "(" . $graphme[$go_time]{$lastregion} . "/" . $alltrials . ")";
# }
# print "\n";
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
$lastregion = $thisregion;
if ($thisframe >= ($trigger + $go_time)) {
$toohigh = 1;
}


} else { # end if
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
$lastregion = $thisregion;

}
} # end else

# record this trial and block number
$lasttrial = $thistrial;
$lastblock = $thisblock;

}
}

  $dbox_out->Subwidget("textbox_t")->delete("1.0", 'end');
for $divreg (keys %{$graphme[$o]}) {
 $dbox_out->Subwidget("textbox_t")->insert('end', $divreg . "\t");

}

$dbox_out->Subwidget("textbox_t")->insert('end', "iter\t\n");


# for each frame
for $o (0 .. $go_time) {
# for each region
for $divreg (keys %{$graphme[$o]}) {
if ($alltrials != 0) {
# divide by the number of fixations
$thiscumu = $graphme[$o]{$divreg} / $alltrials;
} else {
$thiscumu = 0;
}
$xcoord = ((400 / $go_time) * $o) + $mgn;
$ycoord = $bdr + (100 * (1-$thiscumu));
# add coordinates to list
push @{ $coordlist{$divreg} }, $xcoord, $ycoord;
$thiscumu_dec = sprintf("%.3f", $thiscumu);
$dbox_out->Subwidget("textbox_t")->insert('end', $thiscumu_dec . "\t");

}
$dbox_out->Subwidget("textbox_t")->insert('end', "\n");

}

# $coordlist{"BM"} = [$mgn, $bdr + 10, $mgn + 400, $bdr + 10];
# $coordlist{"TP"} = [$mgn, $bdr + 20, $mgn + 400, $bdr + 20];
# $coordlist{"RT"} = [$mgn, $bdr + 30, $mgn + 400, $bdr + 30];
# $coordlist{"LT"} = [$mgn, $bdr + 40, $mgn + 400, $bdr + 40];
# $coordlist{"XX"} = [$mgn, $bdr + 50, $mgn + 400, $bdr + 50];

#output coordinates for each region
$c = 0;
for $drawregs (sort keys %{$graphme[0]}) {
if ($draw_regions =~ /$drawregs/) {
$graph->createLine(@{$coordlist{$drawregs}}, -fill => $colors{$drawregs}, -tags => "fooline", -joinstyle => "round", -width => 2);
$cumuprob = int((((($coordlist{$drawregs}[-1] - $bdr)/100) * - 1) + 1) * 1000);
$cumuprob = $cumuprob / 10;
$graph->createText(427,$coordlist{$drawregs}[-1], -text => $cumuprob, -anchor => "w", -tags => "fooline", -font => "Trebuchet 8 normal", -fill => $colors{$drawregs});
# $graph->createText(427,$coordlist{$drawregs}[-1], -text => $drawregs, -anchor => "w", -tags => "fooline", -font => "Trebuchet 8 normal", -fill => $colors{$drawregs});
}
$c += 1;
}

# print array for test purposes
# print "{ ";
# for $nameregs (keys %{$graphme[0]}) {
#  print "$nameregs ";
# }
# print "}\n";

# print data to stdout
# for $k (0 .. $#graphme) {
#    print "{ ";
#    for $regs (keys %{$graphme[$k]}) {
#        print "$graphme[$k]{$regs}  ";
#    }
#    print "}\n";
# }
$worksheet = $workbook->Worksheets($currentsheet);
$workbook->Worksheets($currentsheet)->Activate();
#print $alltrials . "\n";
# print $worksheet->{'Name'} . "\n";
$msg_foo = "Cumulative probability graph created for selected condition.";

$file4_mb->eventGenerate('<Escape>');

}



sub graphscprob {
$dots_foo = "";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();


#clear lines
foreach (sort values %rgn_abbr) {
$graph->delete("fooline");
}

# initialize array for time window to prevent irriating errors in -w mode
undef $graphme;
undef %coordlist;

my $trigger = 0;
my $lastblock = -1;
my $lasttrial = -1;
my $alltrials = 0;

# get all lines
my $grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


$currentsheet = $worksheet->{'Index'};
for ($h = 0; $h <= $go_time; $h++) {
foreach (sort values %rgn_abbr) {
$graphme[$h]{$_} = 0;
}
}

for $p (1 .. $workbook->Worksheets->Count) {
$worksheet = $workbook->Worksheets($p);
$workbook->Worksheets($p)->Activate();

sortxlsub();
$dots_foo .= "S$p ... ";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();


$lastblock = -1;
$lasttrial = -1;

# get all lines
undef $grapharray;
$grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
$rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


# initialize last frame as 0 or trigger

# loop through all lines
for $m (2 .. $rowcount) {

# get data out of array
$mrow = $m - 1;
$thisblock = $$grapharray[$mrow][1];
$thistrial = $$grapharray[$mrow][2];
$thisframe = $$grapharray[$mrow][3];
$thisregion = $$grapharray[$mrow][4];
$thiscnd1 = $$grapharray[$mrow][5];
$thiscnd2 = $$grapharray[$mrow][6];
$thiscnd3 = $$grapharray[$mrow][7];



# get trigger for this trial
# in future version

# initialize new block/trial loop
if ($lastblock != $thisblock || $lasttrial != $thistrial) {

# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region
$lastregion = $thisregion;

# reset toohigh
$toohigh = 0;

if ($trigger_exists == 1) {
$trigger = $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set];
# print $thistrial . " - " . $this_c1 . " - " . $this_c2 . " - " . $this_c3 . " - " . $trigger_set . " - " . $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set] . "\n";
} else {
$trigger = 0;
}

if ($thiscnd1 eq $c1_abbr{$this_c1} && $thiscnd2 eq $c2_abbr{$this_c2} && $thiscnd3 eq $c3_abbr{$this_c3}) {
$alltrials += 1;
}


} else {
# for each frame, if the conditions match,
# and it's post trigger
if ($thiscnd1 eq $c1_abbr{$this_c1} && $thiscnd2 eq $c2_abbr{$this_c2} && $thiscnd3 eq $c3_abbr{$this_c3} && $thisframe >= $trigger && $toohigh == 0) {
# print "$m\n";
# from the last frame number to this one -1,

$graphme[$thisframe - $trigger]{$thisregion} += 1;

# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
$lastregion = $thisregion;
if ($thisframe >= ($trigger + $go_time)) {
$toohigh = 1;
}
} # end if
} # end else

# record this trial and block number
$lasttrial = $thistrial;
$lastblock = $thisblock;

}
}

  $dbox_out->Subwidget("textbox_t")->delete("1.0", 'end');
for $divreg (keys %{$graphme[$o]}) {
 $dbox_out->Subwidget("textbox_t")->insert('end', $divreg . "\t");

}

$dbox_out->Subwidget("textbox_t")->insert('end', "iter\t\n");

my $binsize = 6;
for $divreg (keys %{$graphme[$o]}) {
$bin_count{$divreg} = $binsize;
$tot_prob{$divreg} = 0;
}

# for each frame
for $o (0 .. $go_time) {

# add up all of the regions
$regtot = 0;
for $addreg (keys %{$graphme[$o]}) {
$regtot += $graphme[$o]{$addreg};
}

# for each region
for $divreg (keys %{$graphme[$o]}) {
if ($regtot != 0) {
# divide by the number of fixations
$thisprob = $graphme[$o]{$divreg} / $alltrials;
} else {
$thisprob = 0;
}

if ($bin_count{$divreg} == 6) {
$tot_prob{$divreg} += $thisprob;
$bin_count{$divreg} += 1;

$xcoord = ((400 / $go_time) * $o) + $mgn;
$ycoord = $bdr + (100 * (1-$tot_prob{$divreg}));
# add coordinates to list
push @{ $coordlist{$divreg} }, $xcoord, $ycoord;
$thisprob_dec = sprintf("%.3f", $tot_prob{$divreg});
$dbox_out->Subwidget("textbox_t")->insert('end', $thisprob_dec . "\t");
$bin_count{$divreg} = 1;
$tot_prob{$divreg} = 0;
$bin_print = 1;
} else {
$tot_prob{$divreg} += $thisprob;
$bin_count{$divreg} += 1;
$bin_print = 0;
}

}
if ($bin_print == 1) {
$dbox_out->Subwidget("textbox_t")->insert('end', "$o\t\n");
}
}

# thisprob needs to be printed out somewhere for each thing. tab after each, and newline at the end. write out to a box of some sort?

# $coordlist{"BM"} = [$mgn, $bdr + 10, $mgn + 400, $bdr + 10];
# $coordlist{"TP"} = [$mgn, $bdr + 20, $mgn + 400, $bdr + 20];
# $coordlist{"RT"} = [$mgn, $bdr + 30, $mgn + 400, $bdr + 30];
# $coordlist{"LT"} = [$mgn, $bdr + 40, $mgn + 400, $bdr + 40];
# $coordlist{"XX"} = [$mgn, $bdr + 50, $mgn + 400, $bdr + 50];

#output coordinates for each region
$c = 0;
for $drawregs (sort keys %{$graphme[0]}) {
if ($draw_regions =~ /$drawregs/) {
$graph->createLine(@{$coordlist{$drawregs}}, -fill => $colors{$drawregs}, -tags => "fooline", -joinstyle => "round", -width => 2);
# print $drawregs . "\n";
}
$c += 1;
}

# print array for test purposes
# print "{ ";
# for $nameregs (keys %{$graphme[0]}) {
#  print "$nameregs ";
# }
# print "}\n";

# print data to stdout
# for $k (0 .. $#graphme) {
#    print "{ ";
#    for $regs (keys %{$graphme[$k]}) {
#        print "$graphme[$k]{$regs}  ";
#    }
#    print "}\n";
# }
$worksheet = $workbook->Worksheets($currentsheet);
$workbook->Worksheets($currentsheet)->Activate();

# print $worksheet->{'Name'} . "\n";
$msg_foo = "Momentary probability graph created for selected condition.";
$file4_mb->eventGenerate('<Escape>');


}

sub graphsccumu {
$dots_foo = "";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();

#clear lines
foreach (sort values %rgn_abbr) {
$graph->delete("fooline");
}

# initialize array for time window to prevent irriating errors in -w mode
undef $graphme;
undef %coordlist;

my $trigger = 0;
my $lastblock = -1;
my $lasttrial = -1;
my $alltrials = 0;

# get all lines
my $grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


$currentsheet = $worksheet->{'Index'};
for ($h = 0; $h <= $go_time; $h++) {
foreach (sort values %rgn_abbr) {
$graphme[$h]{$_} = 0;
}
}

for $p (1 .. $workbook->Worksheets->Count) {
$worksheet = $workbook->Worksheets($p);
$workbook->Worksheets($p)->Activate();

sortxlsub();
$dots_foo .= "S$p ... ";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();

$lastblock = -1;
$lasttrial = -1;

# get all lines
undef $grapharray;
$grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
$rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


# initialize last frame as 0 or trigger

# loop through all lines
for $m (2 .. $rowcount) {

# get data out of array
$mrow = $m - 1;
$thisblock = $$grapharray[$mrow][1];
$thistrial = $$grapharray[$mrow][2];
$thisframe = $$grapharray[$mrow][3];
$thisregion = $$grapharray[$mrow][4];
$thiscnd1 = $$grapharray[$mrow][5];
$thiscnd2 = $$grapharray[$mrow][6];
$thiscnd3 = $$grapharray[$mrow][7];



# get trigger for this trial
# in future version

# initialize new block/trial loop
if ($lastblock != $thisblock || $lasttrial != $thistrial) {

# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region
$lastregion = $thisregion;

if ($trigger_exists == 1) {
$trigger = $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set];
#  print $thistrial . " - " . $this_c1 . " - " . $this_c2 . " - " . $this_c3 . " - " . $trigger_set . " - " . $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set] . "\n";
} else {
$trigger = 0;
}


# reset toohigh
$toohigh = 0;
foreach (sort values %rgn_abbr) {
$stopcumu{$_} = 0;
}
if ($thiscnd1 eq $c1_abbr{$this_c1} && $thiscnd2 eq $c2_abbr{$this_c2} && $thiscnd3 eq $c3_abbr{$this_c3}) {
$alltrials += 1;
}

} else {
# for each frame, if the conditions match,
# and it's post trigger
if ($thiscnd1 eq $c1_abbr{$this_c1} && $thiscnd2 eq $c2_abbr{$this_c2} && $thiscnd3 eq $c3_abbr{$this_c3} && $thisframe >= $trigger && $toohigh == 0 && $stopcumu{$lastregion} == 0) {
$stopcumu{$lastregion} = 1;
# print "$m\n";
# from the last frame number to this one -1,
for $n ($lastframe .. $trigger + $go_time) {
# add one to each frame for the last region
if ($n > $trigger + $go_time) {
next;
}
# don't let negative numbers get you down.
if ($n - $trigger < 0) {
next;
}
$graphme[$n - $trigger]{$thisregion} += 1;
# $zoog = $n-$trigger;
# print $zoog . " ";
# print $n . " - " . $trigger . " = " . $zoog . " : " . $lastregion . "\n";
}
# if ($lastregion eq "TL") {
# print "\n(" . $p . ")" . $thistrial . ": " . $lastregion . "(" . $graphme[$go_time]{$lastregion} . "/" . $alltrials . ")";
# }
# print "\n";
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
$lastregion = $thisregion;
if ($thisframe >= ($trigger + $go_time)) {
$toohigh = 1;
}


} else { # end if
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
$lastregion = $thisregion;

}
} # end else

# record this trial and block number
$lasttrial = $thistrial;
$lastblock = $thisblock;

}
}

  $dbox_out->Subwidget("textbox_t")->delete("1.0", 'end');
for $divreg (keys %{$graphme[$o]}) {
 $dbox_out->Subwidget("textbox_t")->insert('end', $divreg . "\t");

}

$dbox_out->Subwidget("textbox_t")->insert('end', "iter\t\n");


# for each frame
for $o (0 .. $go_time) {
# for each region
for $divreg (keys %{$graphme[$o]}) {
if ($alltrials != 0) {
# divide by the number of fixations
$thiscumu = $graphme[$o]{$divreg} / $alltrials;
} else {
$thiscumu = 0;
}
$xcoord = ((400 / $go_time) * $o) + $mgn;
$ycoord = $bdr + (100 * (1-$thiscumu));
# add coordinates to list
push @{ $coordlist{$divreg} }, $xcoord, $ycoord;
$thiscumu_dec = sprintf("%.3f", $thiscumu);
$dbox_out->Subwidget("textbox_t")->insert('end', $thiscumu_dec . "\t");

}
$dbox_out->Subwidget("textbox_t")->insert('end', "\n");

}

# $coordlist{"BM"} = [$mgn, $bdr + 10, $mgn + 400, $bdr + 10];
# $coordlist{"TP"} = [$mgn, $bdr + 20, $mgn + 400, $bdr + 20];
# $coordlist{"RT"} = [$mgn, $bdr + 30, $mgn + 400, $bdr + 30];
# $coordlist{"LT"} = [$mgn, $bdr + 40, $mgn + 400, $bdr + 40];
# $coordlist{"XX"} = [$mgn, $bdr + 50, $mgn + 400, $bdr + 50];

#output coordinates for each region
$c = 0;
for $drawregs (sort keys %{$graphme[0]}) {
if ($draw_regions =~ /$drawregs/) {
$graph->createLine(@{$coordlist{$drawregs}}, -fill => $colors{$drawregs}, -tags => "fooline", -joinstyle => "round", -width => 2);
$cumuprob = int((((($coordlist{$drawregs}[-1] - $bdr)/100) * - 1) + 1) * 1000);
$cumuprob = $cumuprob / 10;
$graph->createText(427,$coordlist{$drawregs}[-1], -text => $cumuprob, -anchor => "w", -tags => "fooline", -font => "Trebuchet 8 normal", -fill => $colors{$drawregs});
# $graph->createText(427,$coordlist{$drawregs}[-1], -text => $drawregs, -anchor => "w", -tags => "fooline", -font => "Trebuchet 8 normal", -fill => $colors{$drawregs});
}
$c += 1;
}

# print array for test purposes
# print "{ ";
# for $nameregs (keys %{$graphme[0]}) {
#  print "$nameregs ";
# }
# print "}\n";

# print data to stdout
# for $k (0 .. $#graphme) {
#    print "{ ";
#    for $regs (keys %{$graphme[$k]}) {
#        print "$graphme[$k]{$regs}  ";
#    }
#    print "}\n";
# }
$worksheet = $workbook->Worksheets($currentsheet);
$workbook->Worksheets($currentsheet)->Activate();
#print $alltrials . "\n";
# print $worksheet->{'Name'} . "\n";
$msg_foo = "Cumulative probability graph created for selected condition.";

$file4_mb->eventGenerate('<Escape>');

}

sub graphmealt {
$dbox_out->Subwidget("textbox_t")->delete("1.0", 'end');


$dots_foo = "";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();


#clear lines
foreach (sort values %rgn_abbr) {
$graph->delete("fooline");
}

# initialize array for time window to prevent irriating errors in -w mode
undef $graphme;
undef %coordlist;

my $trigger = 0;
my $lastblock = -1;
my $lasttrial = -1;
my $stringline = "";
# get all lines
my $grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


$currentsheet = $worksheet->{'Index'};
for ($h = 0; $h <= $go_time; $h++) {
foreach (sort values %rgn_abbr) {
$graphme[$h]{$_} = 0;
}
}

for $local_c1 (sort keys %c1_abbr) {
for $local_c2 (sort keys %c2_abbr) {
for $local_c3 (sort keys %c3_abbr) {


for $p (1 .. $workbook->Worksheets->Count) {
$worksheet = $workbook->Worksheets($p);
$workbook->Worksheets($p)->Activate();

sortxlsub();
$dots_foo .= "S$p ... ";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();


$lastblock = -1;
$lasttrial = -1;

# get all lines
undef $grapharray;
$grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
$rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


# initialize last frame as 0 or trigger

# loop through all lines
for $m (2 .. $rowcount) {

# get data out of array
$mrow = $m - 1;
$thisblock = $$grapharray[$mrow][1];
$thistrial = $$grapharray[$mrow][2];
$thisframe = $$grapharray[$mrow][3];
$thisregion = $$grapharray[$mrow][4];
$thiscnd1 = $$grapharray[$mrow][5];
$thiscnd2 = $$grapharray[$mrow][6];
$thiscnd3 = $$grapharray[$mrow][7];



# get trigger for this trial
# in future version

# initialize new block/trial loop
if ($lastblock != $thisblock || $lasttrial != $thistrial) {

if ($thiscnd1 eq $c1_abbr{$local_c1} && $thiscnd2 eq $c2_abbr{$local_c2} && $thiscnd3 eq $c3_abbr{$local_c3}) {

#print "\n" . $p . " (" . $thistrial . "): ";
$stringline = "\n" . $c1_abbr{$local_c1} . ":" . $c2_abbr{$local_c2} . ":" . $c3_abbr{$local_c3} . "\t" . $p . "\t" . $thistrial;

$dbox_out->Subwidget("textbox_t")->insert('end', $stringline);

}
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region
$lastregion = $thisregion;

# reset toohigh
$toohigh = 0;

if ($trigger_exists == 1) {
$trigger = $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set];
if ($trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set+1] > 0) {
$end_time = $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set+1];
} else {
$end_time = $trigger + 120;
}
#  print $thistrial . " - " . $this_c1 . " - " . $this_c2 . " - " . $this_c3 . " - " . $trigger_set . " - " . $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set] . "\n";

} else {
$trigger = 0;
$end_time = 120;
}

} else {
# for each frame, if the conditions match,
# and it's post trigger
if ($thiscnd1 eq $c1_abbr{$local_c1} && $thiscnd2 eq $c2_abbr{$local_c2} && $thiscnd3 eq $c3_abbr{$local_c3} && $thisframe >= $trigger && $toohigh == 0) {
# print "$m\n";
# from the last frame number to this one -1,
for $n ($lastframe .. $thisframe-1) {
# add one to each frame for the last region
if ($n > ($end_time) or $n < ($trigger)) {
next;
}
#print $lastregion . " ";
$stringline = "\t" . $lastregion;

$dbox_out->Subwidget("textbox_t")->insert('end', $stringline);

}
if ($thisframe > ($end_time)) {
$toohigh = 1;
}
} # end if
} # end else
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
$lastregion = $thisregion;

# record this trial and block number
$lasttrial = $thistrial;
$lastblock = $thisblock;

}
}
$dots_foo = "";

}}}



$msg_foo = "Strings written to somewhere.";
$file4_mb->eventGenerate('<Escape>');


}


sub makestrings {
my $newlineis = "";
$dbox_out->Subwidget("textbox_t")->delete("1.0", 'end');
  if ($cliptoggle == 1) {
   $clip->Empty();
  }


$dots_foo = "";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();


#clear lines
foreach (sort values %rgn_abbr) {
$graph->delete("fooline");
}

# initialize array for time window to prevent irriating errors in -w mode
undef $graphme;
undef %coordlist;

my $trigger = 0;
my $lastblock = -1;
my $lasttrial = -1;
my $stringline = "";
# get all lines
my $grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
my $rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


$currentsheet = $worksheet->{'Index'};
for ($h = 0; $h <= $go_time; $h++) {
foreach (sort values %rgn_abbr) {
$graphme[$h]{$_} = 0;
}
}

for $local_c1 (sort keys %c1_abbr) {
for $local_c2 (sort keys %c2_abbr) {
for $local_c3 (sort keys %c3_abbr) {


for $p (1 .. $workbook->Worksheets->Count) {
$worksheet = $workbook->Worksheets($p);
$workbook->Worksheets($p)->Activate();

sortxlsub();
$dots_foo .= "S$p ... ";
$msg_foo = "Calculating... " . $dots_foo;
$mw->update();


$lastblock = -1;
$lasttrial = -1;

# get all lines
undef $grapharray;
$grapharray = $worksheet->Cells(1,1)->CurrentRegion->{'Value'};
$rowcount = $worksheet->Cells(1,1)->CurrentRegion->Rows->Count;


# initialize last frame as 0 or trigger

# loop through all lines
for $m (2 .. $rowcount) {

# get data out of array
$mrow = $m - 1;
$thisblock = $$grapharray[$mrow][1];
$thistrial = $$grapharray[$mrow][2];
$thisframe = $$grapharray[$mrow][3];
$thisregion = $$grapharray[$mrow][4];
$thiscnd1 = $$grapharray[$mrow][5];
$thiscnd2 = $$grapharray[$mrow][6];
$thiscnd3 = $$grapharray[$mrow][7];



# get trigger for this trial
# in future version

# initialize new block/trial loop
if ($lastblock != $thisblock || $lasttrial != $thistrial) {
# print $thiscnd1 . "\t" . $thiscnd2 . "\t" . $thiscnd3 . "\n";
if ($thiscnd1 eq $c1_abbr{$local_c1} && $thiscnd2 eq $c2_abbr{$local_c2} && $thiscnd3 eq $c3_abbr{$local_c3}) {

if ($trigger_exists == 1) {
$t_start = $trig_array[$thistrial][$local_c1][$local_c2][$local_c3][$trigger_set];
if ($trig_array[$thistrial][$local_c1][$local_c2][$local_c3][$trigger_set+1] > 0) {
$t_end = $trig_array[$thistrial][$local_c1][$local_c2][$local_c3][$trigger_set+1];
} else {
$t_end = $t_start + 120;
}

} else {
$t_start = 0;
$t_end = 120;
}

$t_time = $t_end - $t_start;

# print "\n" . $p . " (" . $thistrial . "): ";
$stringline = $newlineis . $c1_abbr{$local_c1} . ":" . $c2_abbr{$local_c2} . ":" . $c3_abbr{$local_c3} . "\t" . $p . "\t" . $thistrial . "\t" . $t_time;
$newlineis = "\n";
$dbox_out->Subwidget("textbox_t")->insert('end', $stringline);
  if ($cliptoggle == 1) {
    $currentclip = $clip->Get();
    $clip->Set($currentclip . $stringline);
  }



}
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region
$lastregion = $thisregion;

# reset toohigh
$toohigh = 0;

if ($trigger_exists == 1) {
$trigger = $trig_array[$thistrial][$local_c1][$local_c2][$local_c3][$trigger_set];
# print "\n" . $thistrial . " - " . $this_c1 . " - " . $this_c2 . " - " . $this_c3 . " - " . $trigger_set . " - " . $trig_array[$thistrial][$this_c1][$this_c2][$this_c3][$trigger_set] . "\n";
} else {
$trigger = 0;
}


# print $trigger . " ";

if ($thiscnd1 eq $c1_abbr{$local_c1} && $thiscnd2 eq $c2_abbr{$local_c2} && $thiscnd3 eq $c3_abbr{$local_c3}) {

# print "\n" . $trigger . "\t" . $p . "\t" . $thistrial . "\n";
}

} else {
# for each frame, if the conditions match,
# and it's post trigger
if ($thiscnd1 eq $c1_abbr{$local_c1} && $thiscnd2 eq $c2_abbr{$local_c2} && $thiscnd3 eq $c3_abbr{$local_c3} && $thisframe >= $trigger && $toohigh == 0) {
# print "$m\n";
# from the last frame number to this one -1,

for $n ($lastframe .. $thisframe-1) {

if ($n > ($trigger + $go_time) or $n < ($trigger)) {
next;
}
# print $n . "(" . $lastregion . ")\t";
#print $lastregion . " ";
$stringline = "\t" . $lastregion;

$dbox_out->Subwidget("textbox_t")->insert('end', $stringline);
  if ($cliptoggle == 1) {
    $currentclip = $clip->Get();
    $clip->Set($currentclip . $stringline);
  }

}
if ($thisframe > ($trigger + $go_time)) {
$toohigh = 1;
}
} # end if
} # end else
# set this frame as last frame
$lastframe = $thisframe;
# set this region as last region.
# print $lastregion . "/" . $thisregion . "\t";
$lastregion = $thisregion;

# record this trial and block number
$lasttrial = $thistrial;
$lastblock = $thisblock;

}
}
$dots_foo = "";

}}}



$msg_foo = "Strings written to somewhere.";
$file4_mb->eventGenerate('<Escape>');


}




sub getoutoftown {
my $okgo = 0;
if ($xldocexists == 1) {
  $okgo = MsgBox("Exit sokath?", "Forget to save?", 19);
  #print "$okgo\n";
  if ($okgo == 6) {
    savexldoc();

  }
  $xl_app->Quit();
}
  unless ($okgo == 2) {
  exit;
  }
}

# ---------------------

sub fixslash {
   $_[0] =~ s#/#\\#g;
   return $_[0];
}

sub showabout {
    my $button = $dbox_abo->Show;

}

sub future {
  $msg_foo = "This feature is not yet implemented.";
  $file4_mb->eventGenerate('<Escape>');

}

sub loadtrig {
  $msg_foo = "Loading trigger file.";
  # open trigger file
   $types = [['sokath trigger files', '*.xls']];
#    my $getdoc = $mw->getOpenFile(-filetypes=>$types, -initialdir => $cwd);
   my $getdoc = $mw->getOpenFile(-initialdir => $cwd);
   while ($getdoc) {
   # regular expression to flip slashes!
   #print "$getdoc\n";
   $getdoc = fixslash($getdoc);
   #print "$getdoc\n";
   $xl_trig = CreateObject OLE 'Excel.Application' || die $!;
   $currentsheet = $worksheet->{'Index'};

   $xl_trig->{'Visible'} = 0;
   $xl_trig->{'DisplayAlerts'} = 0;

   if ($workbook_t = $xl_trig->Workbooks->Open($getdoc)) {
    $worksheet_t = $workbook_t->Worksheets(1);
$workbook_t->Worksheets(1)->Activate();

    $msg_foo = "Loaded triggers from $getdoc.";
        my $sortarray = $worksheet_t->Cells(1,1)->CurrentRegion->{'Value'};
        $aaa = 0;
        undef @trig_array;
        undef %trigger_label;
        for (@$sortarray) {
            $bbb = 0;
            $triggercount = 0;
             for (@$_) {
              if ($aaa == 0 and $bbb > 3) {
#               print $_ . "\n";
                 $trigger_label{++$triggercount} = $_; # hash of labels/keys
              } elsif ($aaa > 0 and $bbb == 0) {
                $trig_trial = $_;
#                 print $trig_trial . "\n";
              } elsif ($aaa > 0 and $bbb == 1) {
                $trig_c1 = $_;
#                 print $trig_trial . "\n";
              } elsif ($aaa > 0 and $bbb == 2) {
                $trig_c2 = $_;
#                 print $trig_trial . "\n";
              } elsif ($aaa > 0 and $bbb == 3) {
                $trig_c3 = $_;
#                 print $trig_c3 . "\n";
              } elsif ($aaa > 0 and $bbb > 3) {
                if ($trig_c1 eq "x") {
                  $c1_start = 1;
                  $c1_stop = $c1count;
                 } else {
                  $c1_start = $trig_c1;
                  $c1_stop = $trig_c1;
                 }
                if ($trig_c2 eq "x") {
                  $c2_start = 1;
                  $c2_stop = $c2count;
                 } else {
                  $c2_start = $trig_c2;
                  $c2_stop = $trig_c2;
                 }
                if ($trig_c3 eq "x") {
                  $c3_start = 1;
                  $c3_stop = $c3count;
                 } else {
                  $c3_start = $trig_c3;
                  $c3_stop = $trig_c3;
                 }
               ++$triggercount;
               for ($r = $c1_start; $r <= $c1_stop; $r++) {
                for ($s = $c2_start; $s <= $c2_stop; $s++) {
                 for ($t = $c3_start; $t <= $c3_stop; $t++) {
                     if ($triggercount == 1) {
                      $base_trig = $_;

                     }
                     $trig_array[$trig_trial][$r][$s][$t][$triggercount] = int(($_ - $base_trig)*30);
#                       print $trigger_label{$triggercount} . "\ttrial:" . $trig_trial . "\tc1:" . $r . "\tc2:" . $s . "\tc3:" . $t . "\ttriggercount" . $triggercount . "\t" . $trig_array[$trig_trial][$r][$s][$t][$triggercount] . "\n";

                 }
                }
               }

              }
              $bbb += 1;
            }
#             print "\n";
           $aaa += 1;
#             if ($aaa > 3) {
#              last;
#             }
            }


   } else {
    $oops = OLE->LastError();
    print $oops;
    $msg_foo = "Could not load trigger file: $getdoc.";
   }
   undef $getdoc;
   }
  # read in possible triggers
  # set up triggers array
  # put data into trigger array
  # close trigger file
#   $a = <STDIN>;
  $trigger_exists = 1;
  $xl_trig->Quit();
if ($xldocexists == 1) {

$worksheet = $workbook->Worksheets($currentsheet);
$workbook->Worksheets($currentsheet)->Activate();
}
  $file3_mb->eventGenerate('<Escape>');

}

# change the current subject
sub chgxltrg {
if ($trigger_exists == 1) {
  undef @triglist;
     foreach $i (sort {$a <=> $b; } keys %trigger_label) {
#     print $i . " - " . $trigger_label{$i} . "\n";
#     print $trig_array[5][1][2][1][$i] . " - " . $trigger_label{$i} . "\n";
     push(@triglist, $trigger_label{$i});

     }
  $dbox_trg->Subwidget("listbox_t")->insert('end', @triglist);
  $dbox_trg->Subwidget("listbox_t")->selectionSet(0);
  my $button = $dbox_trg->Show;
  #print "@subjects\n";
  if ($button eq "OK") {
  my $seltrg = $dbox_trg->Subwidget("listbox_t")->curselection();
  my $seltrigger = $dbox_trg->Subwidget("listbox_t")->get($seltrg);
     foreach $i (sort {$a <=> $b; } keys %trigger_label) {
        if ($trigger_label{$i} eq $seltrigger) {
#           print "$i\n";
          $trigger_set = $i;
        }

     }
  $msg_foo = "Trigger is now $seltrigger.";
  $go_trig = $seltrigger;
  $graph_foo = "Time Window: $go_time  Condition: $go_cond  Trigger: $go_trig";
#   $trigger_set = $seltrg + 1;
#  print  $seltrg . $trigger_set . "\n";
  }
  $dbox_trg->Subwidget("listbox_t")->delete(0, 'end');
} else {
$msg_foo = "No trigger, tigger.";
}
}

sub alltrgout {
   $types = [['magic data files', '*.txt']];
#    my $savedoc = $mw->getSaveFile(-filetypes => $types, -defaultextension => ".txt", -initialfile => "testfoo.txt");
   my $savedoc = $mw->getSaveFile(-defaultextension => ".txt", -initialfile => "testfoo.txt");
   my $saved = 1;
   my $filename = $savedoc;
   while ($savedoc) {
   $savedoc = fixslash($savedoc);
   if ($savedoc =~ m#(.*\\)#) {
#     print $1 . "\n";
    $filename = $1;
   }
#    print $filename . "\n";
   $savedoc = "";
   $saved = 0;
   }

   if ($saved == 0) {

   } else {
   $msg_foo = "Could not save $savedoc.";
   }

if ($trigger_exists == 1) {
  foreach $i (sort {$a <=> $b; } keys %trigger_label) {
#     print $i . " - " . $trigger_label{$i} . "\n";
#     print $trig_array[5][1][2][1][$i] . " - " . $trigger_label{$i} . "\n";
  if (!$trigger_label{$i+1}) {
   next;
  }
  $go_trig = $trigger_label{$i};
  $trigger_set = $i;
  $graph_foo = "Time Window: $go_time  Condition: $go_cond  Trigger: $go_trig";
#   print $go_trig . "\n";

open(TRG, ">" . $filename . "out." . $go_trig . ".txt") || die "Hah! That didn't work. $!";
makestrings();
$outwindowcontent = $dbox_out->Subwidget("textbox_t")->get("1.0", "end");
print TRG $outwindowcontent;
close (TRG);
#  print  $trigger_set . "\n";
  }
} else {
$msg_foo = "No trigger, tigger.";
}


}

sub outinfo {
  my $button = $dbox_out->Show;

}

sub toggleup {
if ($updatego == 0) {
 $updatego = 1;
 $msg_foo = "Updating on.";
 $intext_msg = "Data for current subject.";
if ($xldocexists == 1) {
 outxlpage();
}
} else {
 $updatego = 0;
 $msg_foo = "Updating off.";
 $intext_msg = "Updating is off.";
}
}

sub cliptoggle {
if ($cliptoggle == 0) {
 $cliptoggle = 1;
 $msg_foo = "Clipboard on.";
} else {
 $cliptoggle = 0;
 $msg_foo = "Clipboard off.";
}
}
