#! perl -w

use PDF::API2;

$get_file = <STDIN>;
chomp($get_file);
open(IN, $get_file) || die "Hah! That didn't work. $!";

$subs = -1;
$current_sub = -1;
$num_loc = 0;
$max = -1;
$num_cond = -1;
# print $subs . "\n";
while (<IN>) {
  if ($_ =~ m/\[([A-Za-z]+)\]/) {
      print $1 . "\t";
      $loc = $1;
      $loc_label[$num_loc] = $1;
      $num_loc++;
  } elsif ($_ =~ m/\t/) {
      $line = $_;
      chomp $line;
      @args =  split /\t/, $line;
       if ($num_cond == -1) {
           $num_cond = $#args;
       } elsif ($#args != $num_cond) {
           print "WARNING!! UNEQUAL CONDITIONS!!\n";
       }
      if ($args[0] =~ m/^([0-9]+)$/) {
          for ($n = 1; $n <= $#args; $n++) {
             $data[$n][$1]{$loc} = $args[$n];
#              print "$n\t$1\t$loc\t$args[$n]\n";
             $current_sub = $1;
             if ($args[$n] =~ m/([0-9][0-9]*\.?([0-9]+)?)/) {
#                print $1 . "\n";
               if (!$sample[$n]{$loc}) {
                 $total[$n]{$loc} = $args[$n];
                 $sample[$n]{$loc} = 1;
               } else {
                 $total[$n]{$loc} += $args[$n];
                 $sample[$n]{$loc}++;
               }
              if ($args[$n] > $max) {
                 $max = $args[$n];
              }
             } else {
                 print $args[$n] . "\n";
             }
#              print $current_sub . "\n";
          }
      }
  } else {
      if ($subs == -1 && $current_sub != -1) {
         $subs = $current_sub;
#          print $subs . "\n";
#          $subs = -1;
      } elsif ($current_sub != $subs) {
         print "WARNING!! UNEQUAL SUBS!! ($current_sub)\n";
      }
  }

}

print "\n";

for ($d = 0; $d < $num_loc; $d++) {
    for ($c = 1; $c <= $num_cond; $c++) {
         $data[$c][0]{$loc_label[$d]} = $total[$c]{$loc_label[$d]}/$sample[$c]{$loc_label[$d]};
#          print sprintf("%.3f", $total[$c]{$loc_label[$d]}/$sample[$c]{$loc_label[$d]}) . "\t";
    }
#     print "\n";
}

# print "TOTAL $total[1]{'NE'}\n";
# print "SAMPLE $sample[1]{'NE'}\n";
# print "AVG PROP " . sprintf("%.3f", $total[1]{'NE'}/$sample[1]{'NE'}) . "\n";

print "# OF SUBJ\t$subs\n";
print "# OF LOCATIONS\t$num_loc\n";
print "# OF CONDITIONS\t$num_cond\n";
print "MAX VALUE\t$max\n";

$pdf = PDF::API2 -> new;


$total_subs = $subs + 1;

for ($page_leep = 1; $page_leep <= $num_cond; $page_leep++) {
mk_page($page_leep-1, "epoch " . $page_leep);
for ($a = 0; $a < 6; $a++) {
    for ($b = 0; $b < 8; $b++) {
       if ((($b*6) + $a + 1) <= $total_subs) {
#          print $b*6+$a . "\n";
        $some_num = ($b*6)+$a;
#         print $some_num . "\t" . $data[1][($b*6)+$a]{'NW'} . "\t" . $data[1][($b*6)+$a]{'NO'} . "\t" . $data[1][($b*6)+$a]{'NE'} . "\t" . $data[1][($b*6)+$a]{'WE'} . "\t" . $data[1][($b*6)+$a]{'CTR'} . "\t" . $data[1][($b*6)+$a]{'EA'} . "\t" . $data[1][($b*6)+$a]{'SW'} . "\t" . $data[1][($b*6)+$a]{'SO'} . "\t" . $data[1][($b*6)+$a]{'SW'} . "\n";
        draw_grid(30 + ($a*96), 696 - (12 + ($b*96)), ($b*6) + $a, int((1-$data[$page_leep][($b*6)+$a]{'NW'}/$max)*255), int((1-$data[$page_leep][($b*6)+$a]{'NO'}/$max)*255), int((1-$data[$page_leep][($b*6)+$a]{'NE'}/$max)*255), int((1-$data[$page_leep][($b*6)+$a]{'WE'}/$max)*255), int((1-$data[$page_leep][($b*6)+$a]{'CTR'}/$max)*255), int((1-$data[$page_leep][($b*6)+$a]{'EA'}/$max)*255), int((1-$data[$page_leep][($b*6)+$a]{'SW'}/$max)*255), int((1-$data[$page_leep][($b*6)+$a]{'SO'}/$max)*255), int((1-$data[$page_leep][($b*6)+$a]{'SE'}/$max)*255), $page_leep-1);
       }
    }
}
}


$pdf -> saveas($get_file . ".pdf");

print "PDF OUTPUT AS: $get_file.pdf!!!";


sub mk_page {
    $de_font = $pdf->corefont('Helvetica');
    my $this_idx = $_[0];
    my $this_label = $_[1];
    $page[$this_idx] = $pdf -> page();
    $page[$this_idx] -> mediabox(612, 792);
    $label[$this_idx] = $page[$this_idx] -> text();
    $label[$this_idx] -> translate(6,6);
    $label[$this_idx] -> font($de_font, 12);
    $label[$this_idx] -> text($this_label);

}

sub draw_grid {
    my $this_x = $_[0];
    my $this_y = $_[1];
    my $this_idx = $_[2];
    my @shades = @_[3 .. 11];
    my $this_page = $_[12];
    my $text = $page[$this_page] -> text();
    $text -> translate($this_x, $this_y);
    my $font = $pdf->corefont('Helvetica');
    $text -> fillcolor(0);
    $text -> font($font, 12);
    $text -> text($this_idx);
    # print $shades[3] . "\n";
    my $g = $page[$this_page] -> gfx();
    for ($i = 0; $i < 3; $i++) {
        for ($j = 0; $j < 3; $j++) {
          $g -> strokecolor(0);
    #       $shade = int(rand()*256);
          $g -> fillcolor($shades[((2-$j)*3)+$i]);
          $g -> rect($this_x + ($i*24),$this_y + 12 + ($j*24),24,24);
          $g -> fillstroke;
        }
    }
}

