#! perl -w
print "SSAUL Version 0.9 BETA Copyright Karl Bailey 2003-2007.\n\n";

use Getopt::Std;

getopt("i:r:o:c:a:m:p:t:s:",\%options);


print "Unprocessed\n" if $ARGV[0];
foreach (@ARGV) {
   print "$_\n";
}


if (!$options{i}) {
print "Input file? ";
$get_file = <STDIN>;
chomp($get_file);
} else {
$get_file = $options{i};
}

if (!$options{r}) {
print "Region code(s)?";
$get_code = <STDIN>;
chomp($get_code);
} else {
$options{r} =~ s/\#/\|/g;
$get_code = $options{r};
# print "-r " . $get_code . "\n";
}

# print "Region code 2? ";
# $get_code2 = <STDIN>;
# chomp($get_code2);

if (!$options{o}) {
print "Output file? ";
$get_out = <STDIN>;
chomp($get_out);
} else {
$get_out = $options{o};
}

if (!$options{c}) {
print "[1] subject or [2] item analysis? ";
$itsub = <STDIN>;
chomp($itsub);
} else {
$itsub = $options{c};
}

# $itsub = 1;
if (!$options{a}) {

print "\nAnalyses available:\n";
print "[1] Proportion of trials with fixation on a given ROI (entire trial).\n";
print "[2] Average number of fixations per trial on a given ROI (entire trial).\n";
print "[3] Time to first fixation on a given ROI (entire trial).\n";
print "[4] Average number of frames spent fixating on a given ROI (entire trial).\n";
print "[5] Proportion of time spent fixating on a given ROI (entire trial).\n";
print "[6] Momentary fixation probability graphs (entire trial).\n";
print "[7] Momentary fixation probability graphs (entire trial; one subject).\n";
print "[10] Proportion of trials with fixation on a given ROI (initial epoch).\n";
print "[11] Average number of fixations per trial on a given ROI (initial epoch).\n";
print "[12] Average number of fixations per trial on a given ROI (initial epoch; alt).\n";
print "[13] Total frequency of fixation on a given ROI (initial epoch).\n";
print "[14] Proportion of time spent fixating on a given ROI (initial epoch).\n";
print "[15] Initial probability of fixation on a given ROI (initial epoch).\n";
print "[16] Proportion of trials with fixation on a given ROI - MFA format (initial epoch).\n";
print "[20] Proportion of trials with saccade to a given ROI (initial epoch).\n";
print "[21] Total frequency of saccade to a given ROI (initial epoch).\n";
print "[22] Total frequency of saccade per trial to a given ROI (initial epoch).\n";
print "[23] Proportion of trials with saccade to a given ROI - MFA format (initial epoch).\n";
print "[30] Simple string summary.\n";
print "[31] Simplify strings.\n";
print "[32] Fixation pattern frequencies.\n";
print "[33] Single string comp (precedence matching).\n";
print "[34] Single string comp (edit distance).\n";
print "[35] Pre cluster (precedence matching).\n";
print "[36] Pre cluster (edit distance).\n";
print "[37] Markov analysis.\n";

print "Select an analysis? ";
$get_a = <STDIN>;
chomp($get_a);
} else {
$get_a = $options{a};
}

# foreach (%options) {
#  print $_ . "|\n";
# }
# $get_on = <STDIN>;

open(IN, $get_file) || die "Hah! That didn't work. $!";
open(OUT, ">>$get_out") || die "Hah! That didn't work. $!";

if ($get_a == 1) {
$about = "Proportion of trials with fixation on a given ROI (entire trial). $get_file > [$get_code]\t\n\n";
percenttrials();
} elsif ($get_a == 5) {
$about = "Proportion of time spent fixating on a given ROI (entire trial). $get_file > [$get_code]\t\n\n";
percenttime();
} elsif ($get_a == 11) {
$about = "Average number of fixations per trial on a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
numbfixations();
} elsif ($get_a == 2) {
$about = "Average number of fixations per trial on a given ROI (entire trial). $get_file > [$get_code]\t\n\n";
totalfixations();
} elsif ($get_a == 20) {
$about = "Proportion of trials with saccade to a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
saccadeout();
} elsif ($get_a == 23) {
$about = "Proportion of trials with saccade to a given ROI - MFA format (initial epoch). $get_file > [$get_code]\t\n\n";
saccade_MFA();
} elsif ($get_a == 21) {
$about = "Total frequency of saccade to a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
totalsaccade();
} elsif ($get_a == 22) {
$about = "Total frequency of saccade to a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
totalsacc_trial();
} elsif ($get_a == 10) {
$about = "Proportion of trials with fixation on a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
fixout();
} elsif ($get_a == 16) {
$about = "Proportion of trials with fixation on a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
fix_MFA();
} elsif ($get_a == 13) {
$about = "Total frequency of fixation on a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
avgout();
} elsif ($get_a == 14) {
$about = "Proportion of time spent fixating on a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
lengthout();
} elsif ($get_a == 15) {
$about = "Initial probability of fixation on a given ROI (initial epoch). $get_file > [$get_code]\t\n\n";
initfixes();
} elsif ($get_a == 12) {
$about = "Average number of fixations per trial on a given ROI (initial epoch; alt). $get_file > [$get_code]\t\n\n";
avgtrlout();
} elsif ($get_a == 6) {
$about = "Momentary fixation probability graphs (entire trial). $get_file > [$get_code]\t\n\n";
fixall();
} elsif ($get_a == 7) {

if (!$options{"s"}) {
print "Subject #? ";
$get_subs = <STDIN>;
chomp($get_subs);
} else {
$get_subs = $options{"s"};
}

$about = "Momentary fixation probability graphs (entire trial; one subject). $get_file > [Subject $get_subs]\t\n$get_subs\n";
fixone();
} elsif ($get_a == 3) {
$about = "Time to first fixation on a given ROI (entire trial). $get_file > [$get_code]\t\n\n";
timeonset();
} elsif ($get_a == 31) {
simplestr();
} elsif ($get_a == 30) {
simplesum();
} elsif ($get_a == 33) {
similarity();
} elsif ($get_a == 34) {
optmatch();
} elsif ($get_a == 35) {
$about = "Pre cluster (precedence matching). $get_file > [$get_code]\t\n\n";
clustersim();
} elsif ($get_a == 36) {
clusteropt();
} elsif ($get_a == 4) {
$about = "Average number of fixations per trial on a given ROI (entire trial). $get_file > [$get_code]\t\n\n";
avgtime();
} elsif ($get_a == 32) {
$about = "Fixation pattern frequencies.\t\n\n";
fixfreq();
} elsif ($get_a == 37) {
$about = "Markov analysis.\t\n\n";
markov();
}

print "\nBATCH COMMAND STRING:\n";
if ($get_move) {
print "ssaul.pl -i $get_file -r $get_code -o $get_out -c $itsub -a $get_a -m $get_move\n";
} elsif ($get_subs) {
print "ssaul.pl -i $get_file -r $get_code -o $get_out -c $itsub -a $get_a -s $get_subs\n";
} else {
print "ssaul.pl -i $get_file -r $get_code -o $get_out -c $itsub -a $get_a\n";
}


sub setup {
if ($about) {
print OUT $about;
}

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;
push (@infile, $_);
# $args[0] = condition
# $args[1] = subject number
# $args[2] = item number
# $args[3] = length of first region
# $args[4] = first region
# $args[5...] = the rest

$goa{$args[$itsub]} = 1;
$gob{$args[0]} = 1;
}

# foreach (sort keys %goa) {
#    print $_ . "\n";
# }
# foreach (sort keys %gob) {
#    print $_ . "\n";
# }

foreach (sort keys %goa) {
   $zoo = $_;
#    print $zoo . " ";
   foreach (sort keys %gob) {
#       print $zoo . " ";
      $total{$zoo}{$_} = 0;
      $addcode{$zoo}{$_} = 0;
      }
#    print "\n";
}

# foreach (sort keys %total) {
#    print $_ . "\n";
# }
}

sub fixfreq {
seek(IN, 0, 0);
undef %total;
while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 1;

$firstcode = $args[4];
if ($firstcode == "") {
$frodo = "NONE.";
} else {
$frodo = "";
}
for $code (4 .. $thislength + 3) {

$frodo .= $args[$code] . ".";
}
chop $frodo;
# print $frodo;
# print "\n";
$total{$args[0]}{$frodo} += 1;

}



for $aa (sort keys %total) {
$foo = $aa;
print OUT $aa . "\t\n";
for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t" . $total{$foo}{$bb};
print OUT "\n";
}
}


}

sub markov {
seek(IN, 0, 0);
undef %total;
undef %xtotal;
while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 1;

$lastcode = "";
for $code (4 .. $thislength + 3) {
$setypes{$args[0]} = 1;
$setotal{$args[$code]} = 1;
# print $args[0] . "\t" . $args[$lastcode] . "\t" . $args[$code] . "\n";
}
}

for $aaa (sort keys %setypes) {
    for $aab (sort keys %setotal) {
        for $aac (sort keys %setotal) {
            $total{$aaa}{$aab}{$aac} = 0;
        }
    }
}

seek(IN, 0, 0);
while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 1;

$lastcode = "";
for $code (4 .. $thislength + 3) {

if ($lastcode) {
if ($lastcode != $code) {
$total{$args[0]}{$args[$lastcode]}{$args[$code]} += 1;
$xtotal{$args[0]} += 1;
# print $args[0] . "\t" . $args[$lastcode] . "\t" . $args[$code] . "\n";
}
}

$lastcode = $code;
}

}

print OUT "start\tend\t";
for $aa (sort keys %total) {
print OUT $aa . "\t";
}
print OUT "\t\n";

for $bb (sort keys %setotal) {
for $cc (sort keys %setotal) {
 print OUT $bb . "\t" . $cc . "\t";
 for $aa (sort keys %total) {
     print OUT $total{$aa}{$bb}{$cc} . "\t";

}
print OUT "\n";
}
}
# print OUT "total = $xtotal\n";

print OUT "\n\n";

print OUT "start\tend\t";
for $aa (sort keys %total) {
print OUT $aa . "\t";
}
print OUT "\t\n";

for $bb (sort keys %setotal) {
for $cc (sort keys %setotal) {
 print OUT $bb . "\t" . $cc . "\t";
 for $aa (sort keys %total) {
     print OUT sprintf("%.3f", $total{$aa}{$bb}{$cc}/$xtotal{$aa}) . "\t";

}
print OUT "\n";
}
}


}

sub simplestr {
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp($_);
@args =  split /\t/, $_;

$thislength = @args - 4;

print OUT $args[0] . "\t" . $args[1] . "\t" . $args[2] . "\t" . $args[3] . "\t";

$last = "THE ABOMINABLE HORTA";
for $code (4 .. $thislength + 3) {
if ($last ne $args[$code] and $args[$code]=~ /^($get_code)$/) {
 print OUT $args[$code] . "\t";
} else {
 # defeat the romulans

}
$last = $args[$code];
}
print OUT "\n";
}
}

sub simplesum {
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp($_);
@args =  split /\t/, $_;

$thislength = @args - 4;

# print OUT $args[0] . "\t" . $args[1] . "\t" . $args[2] . "\t" . $args[3] . "\t";

$last = "THE ABOMINABLE HORTA";
for $code (4 .. $thislength + 3) {
if ($last ne $args[$code] and $args[$code]=~ /^($get_code)$/) {
#  print OUT $args[$code] . "\t";
 $simplesum .= $args[$code] . "_";
} else {
 # defeat the romulans

}
$last = $args[$code];
}
# print OUT "\n";
$sum_list{$args[0]}{$simplesum} += 1;
$simplesum = "";
}
foreach $this_j (sort keys %sum_list) {
print OUT "######### $this_j ##########\n";
foreach $this_k (sort { $sum_list{$this_j}{$b} <=> $sum_list{$this_j}{$a} } keys %{$sum_list{$this_j}}) {
$this_v = $this_k;
chop($this_v);
$this_v =~ s/_/->/g;

print OUT "$sum_list{$this_j}{$this_k}\t$this_v\n";
}
}

}


sub percenttime {
undef %total;
setup();

# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += $thislength;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 1;

$firstcode = $args[4];
for $code (4 .. $thislength + 3) {
if ($stop == 0 && $args[$code] eq $firstcode) {
# print ".";
} else {
$stop = 1;
if ($args[$code]=~ /^($get_code)$/) {
  $addcode{$args[$itsub]}{$args[0]} += 1;
}
}
}


}



print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}
print OUT "\n\n\n";

}

sub avgtime {
undef %total;
setup();

# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 1;

$firstcode = $args[4];
for $code (4 .. $thislength + 3) {
if ($stop == 0 && $args[$code] eq $firstcode) {
# print ".";
} else {
$stop = 1;
if ($args[$code]=~ /^($get_code)$/) {
  $addcode{$args[$itsub]}{$args[0]} += 1;
}
}
}


}



print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}
print OUT "\n\n\n";

}


sub percenttrials {
undef %total;
setup();

# print "hey!";

seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 1;

$halt = 0;
$firstcode = $args[4];
for $code (4 .. $thislength + 3) {
if ($stop == 0 && $args[$code] eq $firstcode) {
# print ".";
} else {
$stop = 1;
# if (($args[$code] eq $get_code || $args[$code] eq $get_code2) && $halt == 0) {
if (($args[$code]=~ /^($get_code)$/) && $halt == 0) {
  $addcode{$args[$itsub]}{$args[0]} += 1;
  $halt = 1;
  #print ".";
}
}
}


}



print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
# print $a . "\n";
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}
print OUT "\n\n\n";

}

sub saccadeout {
undef %total;
setup();

if (!$options{"m"}) {
print "Movement designator? ";
$get_move = <STDIN>;
chomp($get_move);
} else {
$get_move = $options{"m"};
}


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;
$sac_launched = 0;
$sac_code = "";

if ($thislength > 0) {
$firstcode = $args[4];
if ($firstcode eq $get_move) {
$first_fix = "";
} else {
$first_fix = $firstcode;
}
}

if (@args - 1 > $args[3]+5) {
 $gohere = $args[3]+5;
#  print @args . ">" . $gohere . "\t";
} else {
 $gohere = @args - 1;
#  print "foo.\t";
}

for $code (4 .. $gohere) {
if ($first_fix eq "") {
   if ($firstcode ne $get_move) {
   $first_fix = $firstcode;
   }
}


# get beginning of window
if ($first_fix ne "" && $args[$code] ne $first_fix && $sac_launched == 0) {
   $sac_launched = 1;
   $sac_code = $code;
}

$last_saccade = $args[$code];
}

#get end of window


if ($sac_code ne "") {
if ($last_saccade eq $get_move) {
$stopthis = 0;
for $code (($args[3] + 5) .. $thislength + 3) {
    if ($args[$code] ne $get_move && $stopthis == 0) {
     $end_code = $code;
     $stopthis = 1;
    }

}
} else {
if (@args - 1 > $args[3]+4) {
 $end_code = $args[3]+4;
#  print @args . ">" . $end_code . "\n";
} else {
 $end_code = @args - 1;
#   print "foo.\n";
}

}


for $code ($sac_code .. $end_code) {
if ($stop == 1) {
    if (!$args[$code]) {
#       print "foo.\n";
    } else {
    if ($args[$code]=~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
    $stop = 0;
    }
    }
}
}
}




}

print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}

if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}

}

print OUT "\n\n\n";


}

sub saccade_MFA {
undef %total;
setup();

if (!$options{"m"}) {
print "Movement designator? ";
$get_move = <STDIN>;
chomp($get_move);
} else {
$get_move = $options{"m"};
}


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;
$sac_launched = 0;
$sac_code = "";

if ($thislength > 0) {
$firstcode = $args[4];
if ($firstcode eq $get_move) {
$first_fix = "";
} else {
$first_fix = $firstcode;
}
}

if (@args - 1 > $args[3]+5) {
 $gohere = $args[3]+5;
#  print @args . ">" . $gohere . "\t";
} else {
 $gohere = @args - 1;
#  print "foo.\t";
}

for $code (4 .. $gohere) {
if ($first_fix eq "") {
   if ($firstcode ne $get_move) {
   $first_fix = $firstcode;
   }
}


# get beginning of window
if ($first_fix ne "" && $args[$code] ne $first_fix && $sac_launched == 0) {
   $sac_launched = 1;
   $sac_code = $code;
}

$last_saccade = $args[$code];
}

#get end of window


if ($sac_code ne "") {
if ($last_saccade eq $get_move) {
$stopthis = 0;
for $code (($args[3] + 5) .. $thislength + 3) {
    if ($args[$code] ne $get_move && $stopthis == 0) {
     $end_code = $code;
     $stopthis = 1;
    }

}
} else {
if (@args - 1 > $args[3]+4) {
 $end_code = $args[3]+4;
#  print @args . ">" . $end_code . "\n";
} else {
 $end_code = @args - 1;
#   print "foo.\n";
}

}


for $code ($sac_code .. $end_code) {
if ($stop == 1) {
    if (!$args[$code]) {
#       print "foo.\n";
    } else {
    if ($args[$code]=~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
    $stop = 0;
    }
    }
}
}
}




}

print OUT "HIT ANALYSIS\n";
print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}) . "\t";
# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}

if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}

}

print OUT "\n";

print OUT "MISS ANALYSIS\n";
print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $total{$aa}{$bb}-$addcode{$aa}{$bb}) . "\t";
# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}

if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}

}

print OUT "\n\n\n";


}

sub totalsaccade {
undef %total;
setup();

if (!$options{"m"}) {
print "Movement designator? ";
$get_move = <STDIN>;
chomp($get_move);
} else {
$get_move = $options{"m"};
}


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;
$sac_launched = 0;
$sac_code = "";

if ($thislength > 0) {
$firstcode = $args[4];
if ($firstcode eq $get_move) {
$first_fix = "";
} else {
$first_fix = $firstcode;
}
}

if (@args - 1 > $args[3]+5) {
 $gohere = $args[3]+5;
#  print @args . ">" . $gohere . "\t";
} else {
 $gohere = @args - 1;
#  print "foo.\t";
}

$code = 4;

while ($code <= $gohere) {
if ($first_fix eq "") {
   if ($firstcode ne $get_move) {
   $first_fix = $firstcode;
   }
}


# get beginning of window
if ($first_fix ne "" && $args[$code] ne $first_fix && $sac_launched == 0) {
   $sac_launched = 1;
   $sac_code = $code;
}

$last_saccade = $args[$code];

if ($sac_code ne "") {


if ($last_saccade eq $get_move) {
# move until the movement is done
$stillmoving = 1;
while ($stillmoving == 1) {
# update $sac_code to reflect current position
$sac_code += 1;
if ($args[$sac_code] ne $get_move) {
$last_saccade = $args[$sac_code];
# update $last_saccade to the new fixation code.
$stillmoving = 0;
}
}
}

$stillmoving = 1;
while ($stillmoving == 1){
$sac_code += 1;
if ($args[$sac_code] ne $last_saccade) {
$stillmoving = 0;
}
}
    if ($last_saccade =~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
    }


$first_fix = "";
$stop = 1;
$code = $sac_code;
# print $code . " " . $gohere . "\n";
}


$code += 1;
}

#get end of window






}

print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
print OUT sprintf("%.3f", $addcode{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}

if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}

}

print OUT "\n\n\n";


}

sub totalsacc_trial {
undef %total;
setup();

if (!$options{"m"}) {
print "Movement designator? ";
$get_move = <STDIN>;
chomp($get_move);
} else {
$get_move = $options{"m"};
}


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;
$sac_launched = 0;
$sac_code = "";

if ($thislength > 0) {
$firstcode = $args[4];
if ($firstcode eq $get_move) {
$first_fix = "";
} else {
$first_fix = $firstcode;
}
}

if (@args - 1 > $args[3]+5) {
 $gohere = $args[3]+5;
#  print @args . ">" . $gohere . "\t";
} else {
 $gohere = @args - 1;
#  print "foo.\t";
}

$code = 4;

while ($code <= $gohere) {
if ($first_fix eq "") {
   if ($firstcode ne $get_move) {
   $first_fix = $firstcode;
   }
}


# get beginning of window
if ($first_fix ne "" && $args[$code] ne $first_fix && $sac_launched == 0) {
   $sac_launched = 1;
   $sac_code = $code;
}

$last_saccade = $args[$code];

if ($sac_code ne "") {


if ($last_saccade eq $get_move) {
# move until the movement is done
$stillmoving = 1;
while ($stillmoving == 1) {
# update $sac_code to reflect current position
$sac_code += 1;
if ($args[$sac_code] ne $get_move) {
$last_saccade = $args[$sac_code];
# update $last_saccade to the new fixation code.
$stillmoving = 0;
}
}
}

$stillmoving = 1;
while ($stillmoving == 1){
$sac_code += 1;
if ($args[$sac_code] ne $last_saccade) {
$stillmoving = 0;
}
}
    if ($last_saccade =~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
    }


$first_fix = "";
$stop = 1;
$code = $sac_code;
# print $code . " " . $gohere . "\n";
}


$code += 1;
}

#get end of window






}

print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
# print OUT sprintf("%.3f", $addcode{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}

if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}

}

print OUT "\n\n\n";


}

sub fixout {
undef %total;
setup();


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;

# to divide by the total number of trials, then, get rid of the conditional
if ($thislength > 0) {
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;

for $code (4 .. ($args[3] + 4)) {
if ($stop == 1 && $args[$code]) {
    if ($args[$code]=~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
#     $total{$args[$itsub]}{$args[0]} += 1;
    $stop = 0;

}
}
}

} # if line ain't blank


}

print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($total{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}

print OUT "\n\n\n";

}

sub fix_MFA {
undef %total;
setup();


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;

# to divide by the total number of trials, then, get rid of the conditional
if ($thislength > 0) {
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;

for $code (4 .. ($args[3] + 4)) {
if ($stop == 1 && $args[$code]) {
    if ($args[$code]=~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
#     $total{$args[$itsub]}{$args[0]} += 1;
    $stop = 0;

}
}
}

} # if line ain't blank


}

print  OUT "HIT ANALYSIS\n";
print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($total{$aa}{$bb}) {
# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
print OUT sprintf("%.3f", $addcode{$aa}{$bb}) . "\t";
} else {
print OUT "\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}

print OUT "\n";

print  OUT "MISS ANALYSIS\n";
print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($total{$aa}{$bb}) {
# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
print OUT sprintf("%.3f", $total{$aa}{$bb}-$addcode{$aa}{$bb}) . "\t";
} else {
print OUT "\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}

print OUT "\n\n\n";

}

sub initfixes {
undef %total;
setup();


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;

# to divide by the total number of trials, then, get rid of the conditional
if ($thislength > 0) {
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;

for $code (4 .. 4) {
if ($stop == 1 && $args[$code]) {
    if ($args[$code]=~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
#     $total{$args[$itsub]}{$args[0]} += 1;
    $stop = 0;

}
}
}

} # if line ain't blank


}

print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($total{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}

print OUT "\n\n\n";

}

sub avgout {
undef %total;
setup();


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;

# to divide by the total number of trials, then, get rid of the conditional
if ($thislength > 0) {
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;
$stopcode = "XXXXXXXXXX";
for $code (4 .. ($args[3] + 4)) {
if ($stop == 0 && $args[$code] && $args[$code] ne $stopcode) {
    $stop = 1;
    $stopcode = "XXXXXXXXXX";
}
if ($stop == 1 && $args[$code]) {
    if ($args[$code]=~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
#     $total{$args[$itsub]}{$args[0]} += 1;
    $stop = 0;
    $stopcode = $args[$code];
}
}
}

} # if line ain't blank


}

print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($total{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}) . "\t";
} else {
print OUT "\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}

print OUT "\n\n\n";

}

sub avgtrlout {
undef %total;
setup();


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;

# to divide by the total number of trials, then, get rid of the conditional
if ($thislength > 0 && $args[3] > 0) {
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;
$stopcode = "XXXXXXXXXX";
for $code (4 .. ($args[3] + 4)) {
if ($stop == 0 && $args[$code] && $args[$code] ne $stopcode) {
    $stop = 1;
    $stopcode = "XXXXXXXXXX";
}
if ($stop == 1 && $args[$code]) {
    if ($args[$code]=~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;
#     $total{$args[$itsub]}{$args[0]} += 1;
    $stop = 0;
    $stopcode = $args[$code];
}
}
}

} # if line ain't blank


}

print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($total{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}

print OUT "\n\n\n";

}


sub lengthout {
undef %total;
setup();


# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;

# to divide by the total number of trials, then, get rid of the conditional
if ($thislength > 0) {
# $total{$args[$itsub]}{$args[0]} += $args[3];
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;

for $code (4 .. ($args[3] + 4)) {
if ($stop == 1 && $args[$code]) {
    if ($args[$code]=~ /^($get_code)$/) {
    $addcode{$args[$itsub]}{$args[0]} += 1;

}
    $total{$args[$itsub]}{$args[0]} += 1;

}
}

} # if line ain't blank


}

print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($total{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}

print OUT "\n\n\n";

}


sub fixall {
undef %total;

if ($about) {
print OUT $about;
}



# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;

for $code (4 .. $thislength + 3) {
if ($args[$code]) {
    $addcode{$args[0]}{$args[$code]}{$code-4} += 1;
    $total{$args[0]}{$code-4} += 1;

}
}

}

for $aa (sort keys %total) {
$foo = $aa;

print OUT "\n$foo\n\n";
print OUT "\t";
for $bb (sort keys %{$addcode{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $cc (sort {$a<=>$b} keys %{$total{$aa}}) {
  print OUT $cc;
  for $bb (sort keys %{$addcode{$foo}}) {
   if (!$addcode{$aa}{$bb}{$cc}) {
    $addcode{$aa}{$bb}{$cc} = 0;
   }
   if (!$total{$aa}{$cc}) {
    $foo2 = 0;
   } else {
   $foo2 = $addcode{$aa}{$bb}{$cc}/$total{$aa}{$cc};
#    $foo2 = $addcode{$aa}{$bb}{$cc};
   }

   print OUT "\t" . sprintf("%.3f", $foo2);
  }
  print OUT "\n";
}


}

# for $aa (sort {$a<=>$b} keys %total) {
# print OUT $aa . "\t";
# for $bb (sort keys %{$total{$aa}}) {
# # print $b . "\n";
# if ($addcode{$aa}{$bb}) {
# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
# } else {
# print OUT "0.000\t";
#
# }
#
# }
# print OUT "\n";
# }
print OUT "\n\n\n";

}

sub fixone {
undef %total;



if ($about) {
print OUT $about;
}



# print "hey!";
seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
# for this analysis, this should always be 1, I think.
$stop = 1;

for $code (4 .. $thislength + 3) {
if ($args[$code] && $args[1] == $get_subs) {
    $addcode{$args[0]}{$args[$code]}{$code-4} += 1;
    $total{$args[0]}{$code-4} += 1;

}
}

}

for $aa (sort keys %total) {
$foo = $aa;

print OUT "\n$foo\n\n";
print OUT "\t";
for $bb (sort keys %{$addcode{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $cc (sort {$a<=>$b} keys %{$total{$aa}}) {
  print OUT $cc;
  for $bb (sort keys %{$addcode{$foo}}) {
   if (!$addcode{$aa}{$bb}{$cc}) {
    $addcode{$aa}{$bb}{$cc} = 0;
   }
   if (!$total{$aa}{$cc}) {
    $foo2 = 0;
   } else {
   $foo2 = $addcode{$aa}{$bb}{$cc}/$total{$aa}{$cc};
#    $foo2 = $addcode{$aa}{$bb}{$cc};
   }

   print OUT "\t" . sprintf("%.3f", $foo2);
  }
  print OUT "\n";
}


}

# for $aa (sort {$a<=>$b} keys %total) {
# print OUT $aa . "\t";
# for $bb (sort keys %{$total{$aa}}) {
# # print $b . "\n";
# if ($addcode{$aa}{$bb}) {
# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
# } else {
# print OUT "0.000\t";
#
# }
#
# }
# print OUT "\n";
# }
print OUT "\n\n\n";

}


sub numbfixations {
undef %total;
setup();

# print "hey!";

seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 1;

$halt = 0;
$firstcode = $args[4];
for $code (4 .. $args[3]) {
if ($stop == 0 && $args[$code] eq $firstcode) {
# print ".";
} else {
$stop = 1;
# if (($args[$code] eq $get_code || $args[$code] eq $get_code2) && $halt == 0) {
if ($args[$code]) {

if (($args[$code]=~ /^($get_code)$/) && $halt == 0) {
  $addcode{$args[$itsub]}{$args[0]} += 1;
  $halt = 1;
  #print ".";
} elsif (($args[$code]=~ /^($get_code)$/) && $halt == 1) {

} else {
  $halt = 0;

}


} else {
# print $_ . "\n";
}


}
}


}



print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
# print $a . "\n";
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}
print OUT "\n\n\n";

}



sub totalfixations {
undef %total;
setup();

# print "hey!";

seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 1;

$halt = 0;
$firstcode = $args[4];
$thatcode = "XXXXXXX";
for $code (4 .. $thislength + 3) {
if ($stop == 0 && $args[$code] eq $firstcode) {
# print ".";
} else {
$stop = 1;
# if (($args[$code] eq $get_code || $args[$code] eq $get_code2) && $halt == 0) {
if ($args[$code] ne $thatcode && $args[$code]=~ /^($get_code)$/) {
  $addcode{$args[$itsub]}{$args[0]} += 1;
  $thatcode = $args[$code];
  #print ".";
} else {
  $thatcode = $args[$code];
}
}
}


}



print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
# print $a . "\n";
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}
print OUT "\n\n\n";
}


sub timeonset {
undef %total;
setup();

# print "hey!";

seek(IN, 0, 0);

while (<IN>) {
# print ".";
undef @args;
chomp $_;
@args =  split /\t/, $_;


$thislength = @args - 4;
# print $thislength . "\n";

# stop sets whether or not initial state is counted. 1 = counting on 0 = counting off
$stop = 0;

$halt = 0;
$firstcode = $args[4];
$thatcode = "XXXXXXX";
for $code (4 .. $thislength + 3) {
if ($stop == 0 && $args[$code] eq $firstcode) {
# print ".";
} else {
$stop = 1;
# if (($args[$code] eq $get_code || $args[$code] eq $get_code2) && $halt == 0) {
if ($args[$code] ne $thatcode && $args[$code]=~ /^($get_code)$/ && $halt == 0) {
  $addcode{$args[$itsub]}{$args[0]} += $code-3;
  $total{$args[$itsub]}{$args[0]} += 1;
  $thatcode = $args[$code];
  $halt = 1;
  #print ".";
} else {
  $thatcode = $args[$code];
}
}
}


}



print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
# print $a . "\n";
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}
print OUT "\n\n\n";
}


sub similarity {

open(RAW, ">summary.txt") || die "Hah! That didn't work. $!";


undef %total;
setup();

print "Pattern to match?";
$pattern = <STDIN>;
chomp($pattern);

# print $pattern;

undef @args1;
@args1 =  split /\t/, $pattern;
# print @args1;
# print "\n";
# print $length1 . "\n";

# print "hey!";
seek(IN, 0, 0);

$halt = 0;

while (<IN>) {
# print ".";
undef @args;
chomp($_);
@args =  split /\t/, $_;


print RAW $args[0] . " " . $args[1] . " ". $args[2] . "\n";
# print RAW $_ . "\n";

$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

undef @args2;
@args2 = @args[4 .. $thislength + 3];
$length2 = $#args2;
$length1 = $#args1;

if ($halt == 0) {
$halt = 1;
}

foreach (@args2) {
 print RAW $_ . " ";
}
print RAW "\n";

# initialize arrays for xy
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     $hmatrix[$i][$j] = 0;
     $vmatrix[$i][$j] = 0;

   }

}

# create array for entry to subroutine
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     if ($args1[$i] eq $args2[$j]) {
        $hmatrix[$i][$j] = 1;
#         print $i . "," . $j . "\n";
     }
   }

}

$index = 0;
$thism = 999999;
# hdisplay();
@mxy = xymats ();

# initialize arrays for xx
undef @hmatrix;
undef @vmatrix;
$length1 = $#args1;
$length2 = $#args1;

for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     $hmatrix[$i][$j] = 0;
     $vmatrix[$i][$j] = 0;

   }

}

# create array for entry to subroutine (xx)
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     if ($args1[$i] eq $args1[$j]) {
        $hmatrix[$i][$j] = 1;
#         print $i . "," . $j . "\n";
     }
   }

}


$index = 0;
$thism = 999999;

# hdisplay();
@mxx = xymats();

# initialize arrays yy
undef @hmatrix;
undef @vmatrix;
$length1 = $#args2;
$length2 = $#args2;

for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     $hmatrix[$i][$j] = 0;
     $vmatrix[$i][$j] = 0;

   }

}

# create array for entry to subroutine (yy)
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     if ($args2[$i] eq $args2[$j]) {
        $hmatrix[$i][$j] = 1;
#         print $i . "," . $j . "\n";
     }
   }

}


$index = 0;
$thism = 999999;

# hdisplay();
@myy = xymats();

if ($#args1 >= $#args2) {
   $l = $#args1 + 1;
} else {
   $l = $#args2 + 1;
}


$s = 0;
# $k runs out to the greatest number of tuples. change $#mxy if the theory suggests a limit to the tuples.
for ($k = 0; $k <= $#mxy; $k++) {
$tuple = ($k + 1);
print RAW $tuple . ": M(x,y) = " . $mxy[$k] . " M(x,x) = " . $mxx[$k] . " M(y,y) = " . $myy[$k] . " L = " . $l . "\n";
$s += (($mxy[$k] / (sqrt($mxx[$k] * $myy[$k])))/$l);

}
print RAW $s . "\n";
$addcode{$args[$itsub]}{$args[0]} += $s;



}

system("notepad.exe summary.txt");


print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}
print OUT "\n\n\n";

}

sub optmatch {

open(RAW, ">summary.txt") || die "Hah! That didn't work. $!";


undef %total;
setup();

print "Pattern to match?";
$pattern = <STDIN>;
chomp($pattern);

# print $pattern;
$pattern = " \t" . $pattern;

undef @args1;
@args1 =  split /\t/, $pattern;
# print @args1;
# print "\n";
# print $length1 . "\n";

# print "hey!";
seek(IN, 0, 0);

$halt = 0;

while (<IN>) {
# print ".";
undef @args;
chomp($_);

@args =  split /\t/, $_;


print RAW $args[0] . " " . $args[1] . " ". $args[2] . "\n";
# print RAW $_ . "\n";

$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

undef @args2;
$args2[0] = " ";
push (@args2, @args[4 .. $thislength + 3]);
$length2 = $#args2;
$length1 = $#args1;

foreach (@args2) {
 print RAW $_ . " ";
}
print RAW "\n";


if ($halt == 0) {
$halt = 1;
}

undef @compu;
undef @point;
undef @oma;
undef @next;

for ($i = 0; $i <= $length1; $i++) {
for ($j = 0; $j <= $length2; $j++) {
    $compu[$i][$j] = "x";
# lpoint
    $point[0][$i][$j]  = "0";
# upoint
    $point[1][$i][$j]  = "0";
# dpoint
    $point[2][$i][$j]  = "0";

}
}


for ($i = 0; $i <= $length1; $i++) {
    $compu[$i][0] = $i;
    if ($i != 0) {
    $point[1][$i][0] = 1;
    }
}

for ($j = 0; $j <= $length2; $j++) {
    $compu[0][$j] = $j;
    if ($j != 0) {
    $point[0][0][$j] = 1;
    }
}

for ($i = 1; $i <= $length1; $i++) {
for ($j = 1; $j <= $length2; $j++) {
    $min[0] = $compu[$i - 1][$j] + 1;
    $min[1] = $compu[$i][$j - 1] + 1;
    if ($args1[$i] eq $args2[$j]) {
        $tmin = 0;
    } else {
        $tmin = 1;
    }
    $min[2] = $compu[$i - 1][$j - 1] + $tmin;

#     print "L:" . $min[0] . " U:"

    @sorted = sort { $a <=> $b } @min;
    $compu[$i][$j] = $sorted[0];
    if ($sorted[0] == $min[1]) {
        $point[0][$i][$j] = 1;
    }
    if ($sorted[0] == $min[0]) {
        $point[1][$i][$j] = 1;
    }
    if ($sorted[0] == $min[2]) {
        $point[2][$i][$j] = 1;
    }


}
}



# print "data table\n\n";
# for ($i = 0; $i <= $length1; $i++) {
# for ($j = 0; $j <= $length2; $j++) {
#     print $compu[$i][$j] . "\t";
# }
# print "\n";
# }
#
# print "\nleft table\n\n";
# for ($i = 0; $i <= $length1; $i++) {
# for ($j = 0; $j <= $length2; $j++) {
#     print $point[0][$i][$j] . "\t";
# }
# print "\n";
# }
#
# print "\nup table\n\n";
# for ($i = 0; $i <= $length1; $i++) {
# for ($j = 0; $j <= $length2; $j++) {
#     print $point[1][$i][$j] . "\t";
# }
# print "\n";
# }
#
# print "\ndiag table\n\n";
# for ($i = 0; $i <= $length1; $i++) {
# for ($j = 0; $j <= $length2; $j++) {
#     print $point[2][$i][$j] . "\t";
# }
# print "\n";
# }
#
# print "\n";

$next[0][0] = $length1;
$next[0][1] = $length2;
$oma[0] = X;
# $yyy = @oma;
# print $yyy . "\n";
# print $compu[$length1][$length2] . "\n";

$goon = 1;
while ($goon > 0) {
$goon = 0;
$ll = $#oma;
undef @toma;
undef @tnext;
for ($l = 0; $l <= $ll; $l++) {
    $ii = $next[$l][0];
    $jj = $next[$l][1];
    if ($compu[$ii][$jj] == 0) {
    if (@toma) {
    $thiso = @toma;
    } else {
    $thiso = 0;
    }
    $toma[$thiso] = $oma[$l];
    $tnext[$thiso][0] = 0;
    $tnext[$thiso][1] = 0;

    } else {
#     print "now at cell " . $ii . "," . $jj . " [" . $compu[$ii][$jj] . "]\n";

    if ($point[0][$ii][$jj] == 1) {
#     print "L ";
    if (@toma) {
    $thiso = @toma;
    } else {
    $thiso = 0;
    }
    $toma[$thiso] = "L" . $oma[$l];
    $tnext[$thiso][0] = $ii;
    $tnext[$thiso][1] = $jj - 1;
    }
    if ($point[1][$ii][$jj] == 1) {
#     print "U ";
    if (@toma) {
    $thiso = @toma;
    } else {
    $thiso = 0;
    }
    $toma[$thiso] = "U" . $oma[$l];
    $tnext[$thiso][0] = $ii - 1;
    $tnext[$thiso][1] = $jj;
    }
    if ($point[2][$ii][$jj] == 1) {
#     print "D ";
    if (@toma) {
    $thiso = @toma;
    } else {
    $thiso = 0;
    }
    if ($args1[$ii] eq $args2[$jj]) {
    $toma[$thiso] = "S" . $oma[$l];
    } else {
    $toma[$thiso] = "D" . $oma[$l];
    }
    $tnext[$thiso][0] = $ii - 1;
    $tnext[$thiso][1] = $jj - 1;
    }
    $goon += $compu[$ii][$jj];
    }
}
undef @next;
@next = @tnext;
undef @oma;
@oma = @toma;
# $xxx = @oma;
# print $xxx . "\n";
}

# print "\n";

$s = -999;
foreach (@oma) {
#  print length . "\n";
#  print RAW $_ . "\n";
 undef @results;
 $results[0] = 0;
 $results[1] = 0;
 $results[2] = 0;

 for ($e = 0; $e < length; $e++) {
#      print substr($_,$e,1);
 $ss = substr($_,$e,1);

 if ($ss eq "S") {
   $results[0] += 1;

 } elsif ($ss eq "D") {
   $results[1] += 1;
 } elsif ($ss eq "U") {
   $results[2] += 1;

 } elsif ($ss eq "L") {
   $results[2] += 1;

 }

 }
#  print "\n";
if (@args1 > @args2) {
 $max = @args1 - 1;
} else {
 $max = @args2 - 1;
}

$finalr = 1 - (($results[2] + $results[1])/$max);
# print $finalr . "\n";

if ($finalr > $s) {
   $s = $finalr;
   $r_ul = $results[2];
   $r_d = $results[1];
   $r_m = $max;
} else {

}

}

print RAW "indels: " . $r_ul . " subs: " . $r_d . " max: " . $r_m . " score: ";
print RAW $s . "\n";
$addcode{$args[$itsub]}{$args[0]} += $s;



}

system("notepad.exe summary.txt");


print OUT "SUBJECT\t";
for $aa (sort {$a<=>$b} keys %total) {
$foo = $aa;
}

for $bb (sort keys %{$total{$foo}}) {
print OUT $bb . "\t";
}
print OUT "\n";

for $aa (sort {$a<=>$b} keys %total) {
print OUT $aa . "\t";
for $bb (sort keys %{$total{$aa}}) {
# print $b . "\n";
if ($addcode{$aa}{$bb}) {
print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
} else {
print OUT "0.000\t";

}

}
print OUT "\n";
}
if ($options{t}) {
for ($ot = 1; $ot <= $options{t}; $ot++) {
  print OUT "x\n";
}
}
print OUT "\n\n\n";

}

sub clustersim {

open(RAW, ">summary.txt") || die "Hah! That didn't work. $!";

undef %total;
setup();

$yplace = 0;
# print OUT "CLUSTER\t";
@infile2 = @infile;

foreach (@infile2) {
$yplace += 1;
print OUT $yplace . "\t";
chomp($_);
print RAW $yplace . "\t" . $_ . "\n";
}
print OUT "\n";

$xplace = 0;
foreach (@infile) {
$xplace += 1;
# print OUT $xplace . "\t";
undef @args1;
chomp($_);
@args_t =  split /\t/, $_;
$thislength = $#args_t;
@args1 = @args_t[4 .. $thislength];
# print @args1;
# print "\n";
# print $length1 . "\n";

# print "hey!";

$halt = 0;


foreach (@infile2) {
# print ".";
undef @args;
chomp($_);
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

undef @args2;
@args2 = @args[4 .. $thislength + 3];
$length2 = $#args2;
$length1 = $#args1;

if ($halt == 0) {
$halt = 1;
}


# initialize arrays for xy
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     $hmatrix[$i][$j] = 0;
     $vmatrix[$i][$j] = 0;

   }

}

# create array for entry to subroutine
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     if ($args1[$i] eq $args2[$j]) {
        $hmatrix[$i][$j] = 1;
#         print $i . "," . $j . "\n";
     }
   }

}

$index = 0;
$thism = 999999;
# hdisplay();
@mxy = xymats ();

# initialize arrays for xx
undef @hmatrix;
undef @vmatrix;
$length1 = $#args1;
$length2 = $#args1;

for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     $hmatrix[$i][$j] = 0;
     $vmatrix[$i][$j] = 0;

   }

}

# create array for entry to subroutine (xx)
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     if ($args1[$i] eq $args1[$j]) {
        $hmatrix[$i][$j] = 1;
#         print $i . "," . $j . "\n";
     }
   }

}


$index = 0;
$thism = 999999;

# hdisplay();
@mxx = xymats();

# initialize arrays yy
undef @hmatrix;
undef @vmatrix;
$length1 = $#args2;
$length2 = $#args2;

for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     $hmatrix[$i][$j] = 0;
     $vmatrix[$i][$j] = 0;

   }

}

# create array for entry to subroutine (yy)
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     if ($args2[$i] eq $args2[$j]) {
        $hmatrix[$i][$j] = 1;
#         print $i . "," . $j . "\n";
     }
   }

}


$index = 0;
$thism = 999999;

# hdisplay();
@myy = xymats();

if ($#args1 >= $#args2) {
   $l = $#args1 + 1;
} else {
   $l = $#args2 + 1;
}


$s = 0;
# $k runs out to the greatest number of tuples. change $#mxy if the theory suggests a limit to the tuples.
for ($k = 0; $k <= $#mxy; $k++) {
$tuple = ($k + 1);
# print RAW $tuple . ": M(x,y) = " . $mxy[$k] . " M(x,x) = " . $mxx[$k] . " M(y,y) = " . $myy[$k] . " L = " . $l . "\n";
$s += (($mxy[$k] / (sqrt($mxx[$k] * $myy[$k])))/$l);

}
print OUT sprintf("%.3f", $s) . "\t";



}
print OUT "\n";
if ($xplace =~ /[05]$/) {
 $thismany = @infile;
 print "Finished $xplace of $thismany iterations\n";
}
# if ($xplace == 11) {
#  exit;
# }
}



# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";
print OUT"\n\n\n";

}

sub clusteropt {

open(RAW, ">summary.txt") || die "Hah! That didn't work. $!";

undef %total;
setup();

$yplace = 0;
# print OUT "CLUSTER\t";
@infile2 = @infile;

foreach (@infile2) {
$yplace += 1;
print OUT $yplace . "\t";
chomp($_);
print RAW $yplace . "\t" . $_ . "\n";
}
print OUT "\n";

$xplace = 0;
foreach (@infile) {
$xplace += 1;
# print OUT $xplace . "\t";
undef @args1;
chomp($_);
@args_t =  split /\t/, $_;
$thislength = $#args_t;
$args1[0] = " ";
push (@args1, @args_t[4 .. $thislength]);
# print @args1;
# print "\n";
# print $length1 . "\n";

# print "hey!";

$halt = 0;


foreach (@infile2) {
# print ".";
undef @args;
chomp($_);
@args =  split /\t/, $_;


$thislength = @args - 4;
$total{$args[$itsub]}{$args[0]} += 1;
# print $thislength . "\n";

undef @args2;
$args2[0] = " ";
push (@args2, @args[4 .. $thislength + 3]);
$length2 = $#args2;
$length1 = $#args1;

if ($halt == 0) {
$halt = 1;
}

undef @compu;
undef @point;
undef @oma;
undef @next;

for ($i = 0; $i <= $length1; $i++) {
for ($j = 0; $j <= $length2; $j++) {
    $compu[$i][$j] = "x";
# lpoint
    $point[0][$i][$j]  = "0";
# upoint
    $point[1][$i][$j]  = "0";
# dpoint
    $point[2][$i][$j]  = "0";

}
}


for ($i = 0; $i <= $length1; $i++) {
    $compu[$i][0] = $i;
    if ($i != 0) {
    $point[1][$i][0] = 1;
    }
}

for ($j = 0; $j <= $length2; $j++) {
    $compu[0][$j] = $j;
    if ($j != 0) {
    $point[0][0][$j] = 1;
    }
}

for ($i = 1; $i <= $length1; $i++) {
for ($j = 1; $j <= $length2; $j++) {
    $min[0] = $compu[$i - 1][$j] + 1;
    $min[1] = $compu[$i][$j - 1] + 1;
    if ($args1[$i] eq $args2[$j]) {
        $tmin = 0;
    } else {
        $tmin = 1;
    }
    $min[2] = $compu[$i - 1][$j - 1] + $tmin;

#     print "L:" . $min[0] . " U:"

    @sorted = sort { $a <=> $b } @min;
    $compu[$i][$j] = $sorted[0];
    if ($sorted[0] == $min[1]) {
        $point[0][$i][$j] = 1;
    }
    if ($sorted[0] == $min[0]) {
        $point[1][$i][$j] = 1;
    }
    if ($sorted[0] == $min[2]) {
        $point[2][$i][$j] = 1;
    }


}
}



# print "data table\n\n";
# for ($i = 0; $i <= $length1; $i++) {
# for ($j = 0; $j <= $length2; $j++) {
#     print $compu[$i][$j] . "\t";
# }
# print "\n";
# }
#
# print "\nleft table\n\n";
# for ($i = 0; $i <= $length1; $i++) {
# for ($j = 0; $j <= $length2; $j++) {
#     print $point[0][$i][$j] . "\t";
# }
# print "\n";
# }
#
# print "\nup table\n\n";
# for ($i = 0; $i <= $length1; $i++) {
# for ($j = 0; $j <= $length2; $j++) {
#     print $point[1][$i][$j] . "\t";
# }
# print "\n";
# }
#
# print "\ndiag table\n\n";
# for ($i = 0; $i <= $length1; $i++) {
# for ($j = 0; $j <= $length2; $j++) {
#     print $point[2][$i][$j] . "\t";
# }
# print "\n";
# }
#
# print "\n";

$next[0][0] = $length1;
$next[0][1] = $length2;
$oma[0] = X;
# $yyy = @oma;
# print $yyy . "\n";
# print $compu[$length1][$length2] . "\n";

$goon = 1;
while ($goon > 0) {
$goon = 0;
$ll = $#oma;
undef @toma;
undef @tnext;
for ($l = 0; $l <= $ll; $l++) {
    $ii = $next[$l][0];
    $jj = $next[$l][1];
    if ($compu[$ii][$jj] == 0) {
    if (@toma) {
    $thiso = @toma;
    } else {
    $thiso = 0;
    }
    $toma[$thiso] = $oma[$l];
    $tnext[$thiso][0] = 0;
    $tnext[$thiso][1] = 0;

    } else {
#     print "now at cell " . $ii . "," . $jj . " [" . $compu[$ii][$jj] . "]\n";

    if ($point[0][$ii][$jj] == 1) {
#     print "L ";
    if (@toma) {
    $thiso = @toma;
    } else {
    $thiso = 0;
    }
    $toma[$thiso] = "L" . $oma[$l];
    $tnext[$thiso][0] = $ii;
    $tnext[$thiso][1] = $jj - 1;
    }
    if ($point[1][$ii][$jj] == 1) {
#     print "U ";
    if (@toma) {
    $thiso = @toma;
    } else {
    $thiso = 0;
    }
    $toma[$thiso] = "U" . $oma[$l];
    $tnext[$thiso][0] = $ii - 1;
    $tnext[$thiso][1] = $jj;
    }
    if ($point[2][$ii][$jj] == 1) {
#     print "D ";
    if (@toma) {
    $thiso = @toma;
    } else {
    $thiso = 0;
    }
    if ($args1[$ii] eq $args2[$jj]) {
    $toma[$thiso] = "S" . $oma[$l];
    } else {
    $toma[$thiso] = "D" . $oma[$l];
    }
    $tnext[$thiso][0] = $ii - 1;
    $tnext[$thiso][1] = $jj - 1;
    }
    $goon += $compu[$ii][$jj];
    }
}
undef @next;
@next = @tnext;
undef @oma;
@oma = @toma;
# $xxx = @oma;
# print $xxx . "\n";
}

# print "\n";

$s = -999;
foreach (@oma) {
#  print length . "\n";
#  print RAW $_ . "\n";
 undef @results;
 $results[0] = 0;
 $results[1] = 0;
 $results[2] = 0;

 for ($e = 0; $e < length; $e++) {
#      print substr($_,$e,1);
 $ss = substr($_,$e,1);

 if ($ss eq "S") {
   $results[0] += 1;

 } elsif ($ss eq "D") {
   $results[1] += 1;
 } elsif ($ss eq "U") {
   $results[2] += 1;

 } elsif ($ss eq "L") {
   $results[2] += 1;

 }

 }
#  print "\n";
if (@args1 > @args2) {
 $max = @args1 - 1;
} else {
 $max = @args2 - 1;
}

if ($max == 0) {
 $finalr = 1;
} else {
$finalr = 1 - (($results[2] + $results[1])/$max);

}

# print $finalr . "\n";

if ($finalr > $s) {
   $s = $finalr;
   $r_ul = $results[2];
   $r_d = $results[1];
   $r_m = $max;
} else {

}

}

print OUT sprintf("%.3f", $s) . "\t";



}
print OUT "\n";
if ($xplace =~ /[05]$/) {
 $thismany = @infile;
 print "Finished $xplace of $thismany iterations\n";
}
# if ($xplace == 2) {
#  exit;
# }

}



# print OUT sprintf("%.3f", $addcode{$aa}{$bb}/$total{$aa}{$bb}) . "\t";

}

close(IN);
close(OUT);

if (!$options{p}) {
system("notepad.exe $get_out");
} else {
print "open your own file, sparky.\n";
}


############################################

sub xymats {
# calculate M
undef @m;
while ($thism > 0) {
$thism = 0;
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     $thism += $hmatrix[$i][$j];
   }

}

if ($thism > 0) {
$m[$index] = $thism;
# print "M(" . $index . ") = " . $m[$index] . "\n";
} else {
#  FIND THE LOST WOMBAT OF XEJARKA!!!
}

# calculate V matrix

for ($i = 0; $i <= $length1; $i++) {
for ($j = 0; $j <= $length2; $j++) {

     $x = 0;
     for ($ii = $i+1; $ii <= $length1; $ii++) {
     for ($jj = $j+1; $jj <= $length2; $jj++) {
         $x += $hmatrix[$ii][$jj];

     }}
     $vmatrix[$i][$j] = $x;

}}

# vdisplay();
$index++;

for ($i = 0; $i <= $length1; $i++) {
for ($j = 0; $j <= $length2; $j++) {

    if ($hmatrix[$i][$j] > 0) {
    $hmatrix[$i][$j] = $vmatrix[$i][$j];
    }
}}

# hdisplay();
}
$total = 0;
foreach (@m) {
  $total += $_;
}
# return $total;
return @m;
} # end sub xymats


sub hdisplay {
print "H$index\n";
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     print $hmatrix[$i][$j] . "\t";
   }
   print "\n";
}
print "\n";
}


sub vdisplay {
print "V$index\n";
for ($i = 0; $i <= $length1; $i++) {

   for ($j = 0; $j <= $length2; $j++) {
     print $vmatrix[$i][$j] . "\t";
   }
   print "\n";
}
print "\n";

}



